Package: unifiedWMWqPCR
Type: Package
Title: Unified Wilcoxon-Mann Whitney Test for testing differential
        expression in qPCR data
Version: 1.49.0
Date: 2018-04-23
Author: Jan R. De Neve & Joris Meys
Maintainer: Joris Meys <Joris.Meys@UGent.be>
Description: This packages implements the unified Wilcoxon-Mann-Whitney
    Test for qPCR data. This modified test allows for testing
    differential expression in qPCR data.
License: GPL (>=2)
Encoding: UTF-8
Depends: methods
Imports: BiocGenerics, limma, stats, graphics
Collate: 'Datasets.R' 'S3Generics.R' 'uwmwEstimate_Class.R'
        'uwmwRes_Class.R' 'allGenerics.R' 'as.matrix.uwmwEstimate.R'
        'as.matrix.uwmwRes.R' 'forestplot_methods.R'
        'getEstimate_methods.R' 'groups.message.R' 'outer.h.f.R'
        'outer.o.f.R' 'plotMethoduwmwRes.R' 'prepdf.R' 'sandwich1.f.R'
        'sandwich2.f.R' 'sandwich3.f.R' 'sort.uwmwRes.R' 'uWMW.H.R'
        'uWMW.O.R' 'uWMW_Extract.R' 'uWMW_internal.R' 'uWMW_methods.R'
        'unifiedWMWqPCR-package.R' 'uwmw_Accessors.R'
        'uwmw_Showmethods.R' 'volcanoplot.R' 'volcano-internal.R'
        'wmw.f.R'
biocViews: DifferentialExpression, GeneExpression,
        MicrotitrePlateAssay, MultipleComparison, QualityControl,
        Software, Visualization, qPCR
RoxygenNote: 7.3.2
git_url: https://git.bioconductor.org/packages/unifiedWMWqPCR
git_branch: devel
git_last_commit: a0757eb
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:42:33 UTC; biocbuild

#' The unified Wilcoxon-Mann-Whitney test for qPCR data
#'
#' This function carries out the unified Wilcoxon-Mann-Whitney test for qPCR data. See De Neve et al. (2013) for more details.
#'
#' This function carries out the unified Wilcoxon-Mann-Whitney test using either Overall normalization (O) or Housekeeping normalization (H) as reference (see De Neve et al., 2013). If the argument \code{housekeeping.names} is specified, housekeeping normalization is considered. Otherwise overall normalization is considered.
#'
#' The function uWMW can deal with data frames and matrices. When using a data frame, you need to specify the arguments \code{groups}, \code{feat.names}, \code{subjects} and \code{value}; each one should contain the name of the related variable in the data frame.
#'
#' When using a matrix, each column is assumed to be a subject and each row a feature. The argument \code{groups} should contain as much values as there are columns in the matrix.
#'
#' @param x An object containing the qPCR measurements. See details.
#' @param groups A vector indicating the groups that need comparing, or a single character telling which variable in the data frame contains the groups. Make sure this vector is as long as the number of replicates in the data set.
#' @param feat.names An (optional) character vector with the names of the features (typically genes or microRNAs) or a single character giving the name of the feature variable. If not specified, the feature names are derived from the row names of the matrix, or from the feature names of the qPCRset object.
#' @param subjects An (optional) character string indicating which variable of the data frame contains the subject id's. Ignored if x is not a data frame.
#' @param value An (optional) character string indicating which variable of the data frame contains the values. Ignored if x is not a data frame.
#' @param housekeeping.names an (optional) vector with the names of one or more housekeeping features. Make sure those names are spelled exactly as in the object.
#' @param transpose In case a matrix is used, should the matrix be transposed? A matrix needs to be transposed when the columns do not represent the replicates. The function expects the columns to be replicates and the rows to be the different features.
#' @param ... For passing arguments between methods and to internal functions.
#'
#' @return An object of the class \code{\link{uwmwRes}}, containing the results of the unified Wilcoxon-Mann-Whitney test. See the help page of the class \code{\link{uwmwRes}} for more information.
#'
#' @author Wrapper methods are written by Joris Meys. Internal functions are written by Jan De Neve.
#'
#' @seealso \code{\link{uwmw_Accessors}} and \code{\link{uwmw_Extract}} for accessing the results, and \code{\link{volcanoplot}} and \code{\link{forestplot}} for plotting them.
#'
#' @references De Neve, J. Thas, O. Ottoy, J.P. and Clement L. (2013) An extension of the Wilcoxon-Mann-Whitney test for analyzing RT-qPCR data. Statistical Applications in genetics and Molecular Biology. 12, 333-346
#'
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#'
#' data(NBdata)
#' NBtest <- uWMW(x = NBdata, groups = "group", sub="subject",feat="miRNA",val="Cq")
#' head(NBtest)
#' as.matrix(NBtest)
#'
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @rdname uWMW-methods
#' @aliases uWMW
#' @aliases uWMW,matrix-method
setMethod("uWMW", signature="matrix",
  function(x,groups,housekeeping.names=NULL,transpose=FALSE,feat.names=NULL){
    if(transpose) x <- t(x)
    if(!is.null(feat.names)){
      ngn <- length(feat.names)
      if(ngn != nrow(x)) stop("Length feat.names doesn't match the data")
      rownames(x) <- feat.names
    }
    .uWMW(x,groups,housekeeping.names)
  }
  )

#' @rdname uWMW-methods
#' @aliases uWMW,data.frame-method
setMethod("uWMW",signature="data.frame",
  function(x,groups,feat.names,subjects,value,...){
    # check all arguments
    if(any(missing(groups),
           missing(feat.names),
           missing(value),
           missing(subjects)))
      stop("When using uWMW on a data frame, the arguments groups, feat.names, value and subjects have to be specified.")

    mat <- prep.df(x,feat.names,subjects,value)

    id <- match(colnames(mat),x[,subjects])
    uWMW(mat,groups=x[id,groups],...)


  })

# Internal function to show the group order
# Need a vector of 2, as contained in groupinfo slot

groups.message <- function(groups)
{
  group.left <- groups[1]
  group.right <- groups[2]
  prob.print <- paste("Fitted probabilities: P(",group.left," < ", group.right, ") + 0.5 P(", group.left," = ", group.right,")", sep ="")
  return(prob.print)
}

#' S3 method as.matrix for uwmwEstimate objects.
#' 
#' For \code{\link{uwmwEstimate}} objects, an \code{as.matrix} method is defined that transforms the object to a numeric matrix with the following columns:
#' \describe{
#'   \item{\code{est}:}{ The estimates}
#'   \item{\code{se}:}{ The standard errors on estimates.}
#'   \item{\code{ll}}{lower limit of the confidence interval}
#'   \item{\code{ul}}{upper limit of the confidence interval}
#' }
#' The row names are the names of the tested genes/features. The matrix takes the ordering in the object into account if necessary.
#' 
#' @param x a uwmwEstimate object
#' @param ... currently ignored
#' 
#' @return A matrix with the columns specified above.
#' 
#' @author Joris Meys
#' 
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' NBest <- getEstimate(NBtest,"p")
#' as.matrix(NBtest)
#' 
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @name as.matrix.uwmwEstimate
#' @rdname as.matrix.uwmwEstimate
#' @method as.matrix uwmwEstimate
#' @export

as.matrix.uwmwEstimate <- function(x,...){
  out <- cbind(
    est     = x@est,       
    se      = x@se,
    ul      = x@ul,
    ll      = x@ll
  )
  rownames(out) <- names(x)

#  class(out) <- c("uwmwMatrix",class(out))
  out
}
# NOTE : there's no separate getters for est, se, ...
# as.matrix is used to extract that information. 
# This to avoid an overload of different accessor functions.

# This adds the S4 requested by BioConductor. 
## S4 method calls S3
#' @name as.matrix.uwmwEstimate
#' @rdname as.matrix.uwmwEstimate
#' @aliases as.matrix,uwmwEstimate-method
setMethod("as.matrix", "uwmwEstimate", as.matrix.uwmwEstimate)

## S4 coercion calls S4 method
setAs("uwmwEstimate", "matrix", function(from) as.matrix(from))

# Sandwich estimator 2
# 
# This function is internal and not to be called by the user

sandwich2.f <- function(Y, g1, g2)
{
  Y1 <- na.omit(Y[g1])
  Y2 <- na.omit(Y[g2])
  return(sum(sapply(Y2, function(x) sum(1*(Y1 < x) + 0.5*(Y1 == x)))^2))  
}

#' Extract data from uwmwRes and uwmwEstimate objects.
#'
#' For both uwmwRes and uwmwEstimate objects, you can use the square bracket operators to extract information much like you would do for a matrix.
#'
#' The features can be extracted using the row index, and the estimates as
#'
#' @param x a \code{\link{uwmwRes}} object
#' @param i numeric or character vector
#' @param j optional numeric or character vector
#' @param drop logical value. If set to FALSE and the result of the extraction is a single row or column, dimensions are dropped. Defaults to \code{TRUE}.
#'
#' @return mostly a matrix, unless \code{drop=TRUE} and a single row or column is selected. Then a vector.
#'
#' @examples
#' # With an uwmwRes object
#' data(NBmat)
#' NBtest <- uWMW(NBmat,NBgroups)
#' # These two lines are the same
#' NBtest["hsa-mir-1"]
#' NBtest["hsa-mir-1", ]
#' # These two not
#' str(NBtest["hsa-mir-1",,drop=FALSE])
#' str(NBtest["hsa-mir-1",])
#' # These two give the same data, but in a different way:
#' se(NBtest) # unnamed
#' NBtest[,"se"] #
#'
#' # With an uwmwEstimate object
#' NBodds <- getEstimate(NBtest,"odds")
#' gnames <- grep("let",names(NBodds),value=TRUE)
#' NBodds[gnames]
#' NBodds[gnames,c("ll","ul")]
#'
#' @name uwmw_Extract
#' @rdname uwmw_Extract
#' @aliases [,uwmwRes,character-method
#' @export
setMethod("[",signature(x="uwmwRes",i="character",j="ANY"),
          function(x,i,j,drop=TRUE){
            id <- match(i,names(x),0L)
            if(any(id==0)) warning("Some features could not be found in the object.")

            out <- x[id,j,drop=drop]
            return(out)

          }
)

# method [] method
#' @export
#' @rdname uwmw_Extract
setMethod("[",signature(x="uwmwEstimate",i="character",j="ANY"),
          function(x,i,j,drop=TRUE){
            id <- match(i,names(x),0L)
            if(any(id==0)) warning("Some features could not be found in the object.")

            out <- x[id,j,drop=drop]
            return(out)

          }
)


# method [] method
#' @export
#' @rdname uwmw_Extract
setMethod("[",signature(x="uwmwRes",i="ANY",j="ANY"),
          function(x,i,j,drop=TRUE){
            Narg <- nargs() - 1
            no.i <- missing(i)

            if(Narg==2L){
              out <- as.matrix(x)[i,]
            }else{
              if(no.i) i <- seq_len(length(x))
              out <- as.matrix(x)[i,j,drop=drop]

            }
            return(out)
          }
)

# method [] method
#' @export
#' @rdname uwmw_Extract
setMethod("[",signature(x="uwmwEstimate",i="ANY",j="ANY"),
          function(x,i,j,drop=TRUE){
            Narg <- nargs() - 1
            no.i <- missing(i)

            if(Narg==2L){
              out <- cbind(
                y     = x@est[i],
                se    = x@se[i],
                ll    = x@ll[i],
                ul    = x@ul[i]
              )
              rownames(out) <- names(x)[i]
            }else{
              if(no.i) i <- seq_len(length(x))
              xmat <- as.matrix(x)
              out <- xmat[i,j,drop=drop]

            }
            return(out)
          }
)

# Sandwich estimator 1
# 
# This function is internal and not to be called by the user

sandwich1.f <- function(Y, g1, g2)
{
  Y1 <- na.omit(Y[g1])
  Y2 <- na.omit(Y[g2])
  return(sum(sapply(Y1, function(x) sum(1*(x < Y2) + 0.5*(x == Y2)))^2))  
} 

#' S3 method as.matrix for uwmwRes objects.
#' 
#' For \code{\link{uwmwRes}} objects, an \code{as.matrix} method is defined that transforms the object to a numeric matrix with the following columns:
#' \describe{
#'   \item{\code{logor}:}{ The log odds ratio values}
#'   \item{\code{se}:}{ The standard errors on the log OR values.}
#'   \item{\code{or}}{The odds ratio values}
#'   \item{\code{z.value}}{the z values related to the log OR values}
#'   \item{\code{p.value}}{The p values related to the log OR values}
#' }
#' The row names are the names of the tested genes/features. The matrix takes the ordering in the object into account if necessary.
#' 
#' @param x a uwmwRes object
#' @param ... currently ignored
#' 
#' @return A matrix containing the columns specified above.
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' as.matrix(NBtest)
#' 
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @name as.matrix.uwmwRes
#' @rdname as.matrix.uwmwRes
#' @method as.matrix uwmwRes
#' @export
#' 

as.matrix.uwmwRes <- function(x,...){
  out <- cbind(
    logor        = logor(x),
    se           = se(x),
    or           = oddsRatio(x),
    z.value      = zval(x),
    p.value      = pval(x)
  )
  rownames(out) <- names(x)
  out
}

# This adds the S4 requested by BioConductor. 
## S4 method calls S3
#' @name as.matrix.uwmwRes
#' @rdname as.matrix.uwmwRes
#' @aliases as.matrix,uwmwRes-method
setMethod("as.matrix", "uwmwRes", as.matrix.uwmwRes)

## S4 coercion calls S4 method
setAs("uwmwRes", "matrix", function(from) as.matrix(from))

#' Unified Wilcoxon-Mann Whitney Test for qPCR data.
#'
#' This package allows you to carry out the unified Wilcoxon-Mann Whitney
#' Test for qPCR data. If you use this package for research purposes,
#' please cite the following article:
#'
#' De Neve, Jan; Meys, Joris; Ottoy, Jean-Pierre; Clement, Lieven and Thas,
#' Olivier. "UnifiedWMWqPCR: The unified Wilcoxon-Mann-Whitney test for
#' analyzing RT-qPCR data in R." Bioinformatics(2014): Vol.30, Issue 17,
#' pp.2494-2495.
#'
#' Or see \code{citation("unifiedWMWqPCR")}
#'
#' @import methods
#' @importClassesFrom limma MArrayLM
#'
#' @name unifiedWMWqPCR-package
#' @rdname unifiedWMWqPCR-package
#' @aliases unifiedWMWqPCR uWMWqPCR
"_PACKAGE"

#Internal function for calculating the unified Wilcox-Mann-Whitney
# 
# This function is used internally in the S4 method uWMW, and should not be called by the user in general. 
# 
# @param data A matrix with the qPCR data, with the rownames as names for the genes and the columns as replicates.
# @param groups A vector as long as the number of columns in the data matrix. The vector indicates from which group every replicate comes.
# @param housekeeping.names An optional character vector with the names of the housekeeping genes used in the test. If set to NULL, the test is carried out without taking housekeeping genes into account.


.uWMW <- function(data, groups, housekeeping.names = NULL)
{
  if(sum(is.element(housekeeping.names, rownames(data))) != length(housekeeping.names)) 
    stop("One or more housekeeping features names are not valid, please check for typos")
  if(length(groups) != ncol(data))
    stop("Length of 'groups' is not equal to the number of columns of 'data' ")
  
  grouplev <- as.character(unique(groups))
  if(length(grouplev) != 2)
    stop(paste("uWMW needs exactly 2 groups, but",length(grouplev),"were specified."))
  
  if(is.null(housekeeping.names))  
  {
    t.type <- "O"
    housekeeping.names <- character(0)
    results <- uWMW.O(data, groups)
  } else
  {
    t.type <- "H"
    results <- uWMW.H(data, groups, housekeeping.names)
  }
  if(sum(diag(results[[4]]) < 0) > 0) warning("One or more variance estimates are negative")
  z.tmp <- results[[1]]/results[[2]]
  p.tmp <- 2*(1 - pnorm(abs(z.tmp)))

  rownames(results[[4]]) <- colnames(results[[4]]) <- names(results[[3]])

  uwmwRes(
    type         = t.type,
    housekeeping = housekeeping.names,
    names        = names(results[[1]]),
    logOR        = results[[1]],
    se           = results[[2]],
    OR           = exp(results[[1]]),
    z.value      = z.tmp,
    p.value      = p.tmp,
    coef         = results[[3]],
    vcov         = results[[4]],
    groupinfo    = grouplev
    )
}

# Internal calculation function outer.ome.f
# 
# Function is internal and not to be called by the user.

outer.o.f <- function(beta.length, weights)
{
  le <- length(weights)
  Outer1 <- matrix(nrow = beta.length, ncol = beta.length, 0)
  
  Outer1[1,1] <- sum(weights[-le])
  Outer1[-1,1] <- Outer1[1, -1] <- diag(Outer1)[-1] <- weights[-le]
  
  Outer2 <- matrix(nrow = beta.length, ncol = beta.length, 1)
  Outer2[-1,1] <- Outer2[1, -1] <- -1
  Outer2 <- weights[le]*Outer2
  
  Outer <- Outer1 + Outer2
  return(Outer)
}

# Calculation of uWMW without housekeeping genes.
# 
# This function is internal and should not be called by the user. The input is the same as in \code{\link{.uWMW}}

uWMW.O <- function(data, groups)
{
  d.m <- data
  g1 <- groups == unique(groups)[1]
  g2 <- !g1
  
  f.info <- t(apply(d.m, 1, wmw.f, g1, g2))
  f.info[,1] <- ifelse(f.info[,1] > 0.999, 0.999, f.info[,1])
  f.info[,1] <- ifelse(f.info[,1] < 0.001, 0.001, f.info[,1])
  fv <- f.info[,1]
  
  odds.f.vec <- f.info[,1]/(1-f.info[,1])
  log.odds.int <- mean(log(odds.f.vec))
  le <- nrow(f.info)
  beta.est <- c(intercept = log.odds.int, log(odds.f.vec[-le]) - log.odds.int)
  
  Outer <- outer.o.f(beta.length = length(beta.est), 
                       weights = fv*(1-fv)*f.info[,2]*f.info[,3])
  
  Middle1 <- outer.o.f(beta.length = length(beta.est), 
                         weights = apply(d.m,1, sandwich1.f, g1, g2) - 
                           fv^2*f.info[,2]*f.info[,3]^2)
  Middle2 <- outer.o.f(beta.length = length(beta.est), 
                         weights = apply(d.m,1, sandwich2.f, g1, g2) - 
                           fv^2*f.info[,2]^2*f.info[,3])   
  Middle3 <- outer.o.f(beta.length = length(beta.est), 
                         weights = f.info[,2]*f.info[,3]*(fv - fv^2) - 
                           apply(d.m,1, sandwich3.f, g1, g2)/4)
  Middle <- Middle1 + Middle2 - Middle3
  
  invOuter <- solve(Outer)
  
  cov.beta <- invOuter %*% Middle %*% invOuter
  logOR <- c(beta.est[-1], -sum(beta.est[-1]))
  names(logOR) <- rownames(d.m)
  SE <- c(sqrt(diag(cov.beta))[-1], sqrt(sum(cov.beta[-1,-1])))             
  return(list(logOR = logOR, SE = SE, coef = beta.est, vcov = cov.beta))
}

# Internal function outer.hme.f
# 
# This function is internal and not to be called by the user

outer.h.f <- function(beta.length, weights, boolean.hkp)
{
  Outer <- matrix(nrow = beta.length, ncol = beta.length, 0)
  
  Outer[1,1] <- sum(weights)
  Outer[-1,1] <- Outer[1, -1] <- diag(Outer)[-1] <-  weights[!boolean.hkp]
  return(Outer)
}

# This file contains S3 generics for plot, coef and vcov
# This way they don't need to be generated automatically.
# Check uwmw_Accessors and plotMethoduwmwRes for 
# the S4 counterparts

# To avoid conflicts.

plot.uwmwRes <- function(x,y,...){
  x.sort <- sort(x,which="p")
  id <- which(x.sort[,"p.value"] < 0.05)
  forestplot(x.sort,order=id,...)
}   

#' Parameters used for the function volcanoplot
#'
#' The parameters described can all be used in the different \link{volcanoplot} methods.
#'
#' The arguments \code{highlight} and \code{names} are chosen in such a way that the function can mimick the behaviour of the \code{volcanoplot} function in the package \code{limma}.
#'
#' @param highlight an integer, indicating how many of the top features should be highlighted. Defaults to 0.
#' @param names an optional character vector giving the names of the genes to be highlighted. If not specified, the features are numbered from most significant to least significant. Default value is \code{NULL}.
#' @param xlab see \code{\link{par}}. Defaults to \code{"Fit"}
#' @param ylab see \code{\link{par}}. Defaults to \code{"Significance"}
#' @param pch see \code{\link{par}}. Defaults to 16
#' @param cex see \code{\link{par}}. Defaults to 0.35 as in the \code{limma} package.
#' @param transf.x a function used to transpose the values on the X axis. Defaults to NULL, unless otherwise specified in the specific methods.
#' @param transf.y a function used to transpose the values on the Y axis. Defaults to NULL, unless otherwise specified in the specific method.
#' @param add.ref a charater value indicating if reference lines for x, y or both axes should be drawn. It takes the values "none", "x", "y" or "both". Default value is "none". If not specified but ref.x or ref.y is, then the reference line is drawn for the X and/or the Y axis.
#' @param ref.x a numerical vector, indicating the value or values at which the reference line(s) should be drawn on the X axis. Defaults to \code{NULL}.
#' @param ref.y a numerical value, indicating the value at which the reference line should be drawn on the Y axis. Defaults to \code{NULL} unless otherwise specified in the specific methods.
#' @param col.x The color for the reference line on the X axis. The argument is passed to the col argument of \code{\link{lines}}, so check that help page for possible values. Defaults to \code{"darkgrey"}
#' @param col.y see col.x, but for the Y axis. If \code{col.x} is specified and \code{col.y} is not, then the value of \code{col.x} is used for \code{col.y}.
#' @param lwd.x The line width for the reference line on the X axis. The argument is passed to the lwd argument of \code{\link{lines}}, so check that help page for possible values. Defaults to 1.
#' @param lwd.y see \code{lwd.x}, but for the Y axis. If \code{lwd.y} is not specified and \code{lwd.x} is, that value is used for \code{lwd.y} as well.
#' @param lty.x The line type for the reference line on the X axis. The argument is passed to the lty argument of \code{\link{lines}}, so check that help page for possible values. Defaults to 1.
#' @param lty.y see \code{lty.x}, but for the Y axis. If \code{lty.y} is not specified and \code{lty.x} is, that value is used for \code{lty.y} as well.
#'
#' @note These parameters belong to the internal function, eventually called by the different S4 methods. This internal function is not exported, and should not be called directly.
#' @examples
#' # see the help page of volcanoplot
#'
#' @importFrom graphics text
#' @include volcanoplot.R
#' @name volcanopar
#' @rdname volcanopar
#' @aliases volcano-par volcanoplot-par volcanoplotpar
NULL
# The function
.volcano <- function(fit,sig,
         highlight= 0,
         names = NULL,
         xlab = "Fit",
         ylab = "Significance",
         pch = 16,
         cex = 0.35,
         col = "black",      # Needed due to that pesky partial matching idiocy messing up when col is passed as an argument. You get multiple matching with col.x and col.y.
         transf.x = NULL,
         transf.y = NULL,
         add.ref=c("none","x","y","both"),
         ref.x = NULL,
         ref.y = NULL,
         col.x = "darkgrey",
         col.y = col.x,
         lwd.x = 1,
         lwd.y = lwd.x,
         lty.x = 1,
         lty.y = lty.x,
         ...){
  # Check the arguments
  if(length(fit) != length(sig)) stop("x and y should have the same length.")

  # Transform if needed
  if(identical(FALSE,transf.x)) transf.x <- NULL
  if(identical(FALSE,transf.y)) transf.y <- NULL

  if(is.null(transf.x)) transf.x <- identity
  if(is.null(transf.y)) transf.y <- identity

  x <- transf.x(fit)
  y <- transf.y(sig)

  # Set the arguments to determine which references to draw.
  mref <- missing(add.ref)
  add.ref <- match.arg(add.ref)

  if(mref){
    add.x <- if(is.null(ref.x)) FALSE else TRUE
    add.y <- if(is.null(ref.y)) FALSE else TRUE
  } else {
    add.x <- if(add.ref %in% c("x","both")) TRUE else FALSE
    add.y <- if(add.ref %in% c("y","both")) TRUE else FALSE
  }

  if(add.x & is.null(ref.x))
    stop("If add.x is TRUE, ref.x should be specified")
  if(add.y & is.null(ref.y))
    stop("If add.y is TRUE, ref.y should be specified")

  # Construct panel.first
  # Ancient coding, but very useful to get the reference lines
  # plotted underneath the points instead of on top of them.

  # make sure you don't mess up somebody elses use of panel.first
  mc <- match.call()
  panel.first <- mc$panel.first

  if(add.x || add.y){
    if(add.x)
      panel.first <- c(panel.first,
                       expression(
                         abline(v=ref.x,col=col.x,lwd=lwd.x,lty=lty.x)
                         )
      )
    if(add.y)
      panel.first <- c(panel.first,
                       expression(
                         abline(h=ref.y,col=col.y,lwd=lwd.y,lty=lty.y)
                       )
      )
  }

  plot(x,y,xlab = xlab,ylab = ylab,pch = pch,cex = cex,
       panel.first=eval(panel.first), ...)

  if (highlight > 0) {
    if (is.null(names))
      names <- 1:length(x)
    names <- as.character(names)
    o <- order(y, decreasing = TRUE)
    i <- o[1:highlight]
    text(x[i], y[i], labels = substring(names[i], 1, 8),
         cex = 0.8, col = "blue")
  }
  invisible()
}

#' Make a volcano plot of the outcome of a uWMW test
#' 
#' This function creates a volcano plot of the outcome of a uWMW test. In this plot, the p-value is plotted against the odd ratio or the log-odds ratio, depending on what interests you most. It allows to quickly see what proportion of results is significant, and what proportion of significant results has a biologically significant chance of being upregulated.
#' 
#' The methods described here all use the same internal function to create the plot
#' 
#' @param fit a uwmwRes object, a matrix with 2 columns or a numeric vector with either odds ratios or the log of odds ratios.
#' @param esttype The estimate that should be plotted from the uwmwRes object. See also \code{\link{getEstimate}}.
#' @param transf.y a function used to transpose the values on the Y axis. For uwmwRes objects, defaults to -log10(y). Passed down to internal function.
#' @param ref.y The location on the Y axis for the reference line.
#' @param coef for compatibility with limma package, see \code{\link{volcanopar}}
#' @param highlight for compatibiity with limma package, see \code{\link{volcanopar}}
#' @param ... arguments passed to the internal function. See \code{\link{volcanopar}}
#' @return invisible NULL 
#' 
#' @examples
#' data(NBmat)
#' housekeeping.id <- grep("let",rownames(NBmat),value=TRUE)
#' NB.Htest <- uWMW(NBmat,NBgroups,housekeeping.id)
#' 
#' volcanoplot(NB.Htest)
#' volcanoplot(NB.Htest,"p")
#' 
#' @author Joris Meys
#' @docType methods
#' @name volcanoplot
#' @rdname volcanoplot-methods
#' @aliases volcanoplot,uwmwRes-method
setMethod("volcanoplot",
  signature=c("uwmwRes"),
  function(fit, 
           esttype=c("logor","or","logodds","odds","p"), 
           transf.y=function(i) -log10(i),ref.y = -log10(0.05),...){
    
    esttype <- match.arg(esttype)
    mc <- match.call()
    # set plotting parameters
    if(is.null(mc$xlab)) xlab <- esttype
    if(is.null(mc$ylab)) ylab <- expression(- log[10]~p ) 
    
    
    yval <- pval(fit)        
    xval <- getEstimate(fit,esttype,se.fit=FALSE,ci=FALSE)
    
    volcanoplot(xval,yval,transf.y=transf.y,ref.y=ref.y,
                xlab=xlab,ylab=ylab,...)
  })


# USE A PLOT METHOD FOR MATRIX
#' @rdname volcanoplot-methods
#' @aliases volcanoplot,matrix-method
setMethod("volcanoplot",
  signature=c("matrix"),
  function(fit,...){
    if(ncol(fit) > 2) stop("matrix should have two columns")
    
    volcanoplot(fit[,1],fit[,2],...)
  }
)

# General method
#' @rdname volcanoplot-methods
#' @aliases volcanoplot,numeric-method
setMethod("volcanoplot",
  signature=c("numeric"),
  function(fit,...){
    .volcano(fit,...)
  }
)

# MArrayLM method
# This is re-implemented to use the internal function of 
# the uWMWqPCR package so it always reacts the same on 
# the different arguments. 
# Passing to limma::volcanoplot was another option, but
# this seemed better in the long run. 
#' @rdname volcanoplot-methods
#' @aliases volcanoplot,MArrayLM-method
setMethod("volcanoplot",
  signature=c("MArrayLM"),
  function(fit,coef=1,highlight=0,...){
    if (is.null(fit$lods)) 
      stop("No B-statistics found, perhaps eBayes() not yet run")
    x <- as.matrix(fit$coef)[, coef]
    y <- as.matrix(fit$lods)[, coef]
    
    # construct the call
    mc <- match.call()
    mc$coef <- NULL
    if(is.null(mc$names)) mc$names <- fit$genes$ID
    if(is.null(mc$xlab)) mc$xlab <- "Log Fold Change"
    if(is.null(mc$ylab)) mc$ylab <- "Log Odds"
    if(is.null(mc$pch)) mc$pch <- 16
    if(is.null(mc$cex)) mc$cex <- 0.35
        
    mc[[1]] <- volcanoplot
    mc$fit <- x
    mc$sig <- y
    eval(mc)
  }        )

#' Quick forest plot of significantly up- and downregulated features.
#' 
#' This function plots a forest plot, normally used in meta analysis, to visualize the odds ratios (OR) and confidence intervals resulting from a call to \code{\link{uWMW}}. It is the default plot function for the \code{\link{uwmwRes}} objects. The results are ordered according to significance, and only the significant results are plotted. This function calls \code{\link{forestplot}} directly. 
#' 
#' @param x an uwmwRes object.
#' @param y ignored for uwmwRes objects
#' @param ... arguments passed down to \code{\link{forestplot}}
#' 
#' @return NULL invisibly
#' 
#' @seealso \code{\link{forestplot}}
#' 
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' plot(NBtest)
#' 
#' @include uwmwRes_Class.R uwmwEstimate_Class.R S3Generics.R
#' @importFrom graphics plot
#' @export
#' @rdname plot
#' @aliases plot,uwmwRes,ANY-method
setMethod("plot",signature=c("uwmwRes","ANY"),plot.uwmwRes)

#' Sort and order method for uWMWRes objects
#'
#' This functions provide sorting functionality for \code{\link{uwmwRes}} objects. It allows to sort the values in the object in order to get the genes with the highest OR, lowest p value, ... The function uses \code{\link{order}} underneath
#'
#' The function does not change the internal order, but changes the slot \code{id} in the object. This slot is used by other functions to give the requested values
#'
#' @param x a uwmwRes object
#' @param decreasing a logical value indicating whether values should be sorted in increasing or decreasing order.
#' @param which a character value indicating on which values should be used to sort on. The possible values are: "or" for sorting on the odds ratio, "p" for sorting on the p value, "se" for sorting on the standard error or "name" for sorting on the gene names.
#' @param na.last a logical value indicating whether NA results should be sorted at the end. See \code{\link{order}} for more information.
#' @param ... currently ignored
#'
#' @return \code{sort} returns a sorted uwmwRes object.
#'
#' @seealso The functions \code{\link{is.unsorted}}, \code{\link{orderedBy}} and \code{\link{getOrder}} to check on the ordered state of a \code{\link{uwmwRes}} object.
#'
#' \code{order} returns the order of the uwmwRes object.
#'
#' \code{unorder} returns a uwmwRes object with the order removed.
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' NBsort <- sort(NBtest,which="name")
#' NBsort[1:10]
#'
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @name sort
#' @rdname sort_uwmwRes
#' @aliases sort,uwmwRes-method
#' @export
setMethod("sort",signature="uwmwRes",function(x,decreasing=FALSE,which=c("or","p","se","name","z"),na.last=TRUE,...){
  which <- match.arg(which)

  which <- match.arg(which)
  getf <- switch(which,"or"=logor,"p"=pval,"se"=se,"name"=names,"z"=zval)
  x@id <- order(getf(x),decreasing=decreasing,na.last=na.last)
  x@orderedBy <- which

  return(x)
}  )

#' @rdname sort_uwmwRes
#' @aliases unorder unorder,ANY-method
#' @export
setMethod("unorder",
          signature="ANY",
          function(x,...){
            theclass <- class(x)
            stop(paste("unorder is not defined for",theclass,"objects."))
          })

#' @rdname sort_uwmwRes
#' @export
setMethod("unorder",
          signature="uwmwRes",
          function(x,...){
            if(!is.unsorted(x)){
              x@orderedBy <- "none"
              x@id <- seq_len(length(x))
            }
            return(x)
          })
# Just to make sure that they don't try this one.
#' @rdname sort_uwmwRes
#' @param method Argument of the generic, ignored here. See also
#' \code{\link[BiocGenerics]{order}}
#' @export
setMethod("order",
          signature="uwmwRes",
          function(...,na.last=TRUE,decreasing=FALSE,
                   method = c("auto","shell","radix")
                   ){
            stop("order gives no sensible output when used on uwmwRes objects.")
            NULL

          })

#' Class uwmwRes
#' 
#' This class represents the results of the unified Wilcoxon-Mann-Whitney test. It contains all necessary information for the vulcano and forest plots. For this class a number of methods is foreseen, among which accessors for every slot.
#' 
#' @section Slots:
#' \describe{
#'    \item{\code{type}:}{object of class \code{"character"}, containing the type of analysis (either H or O, see \code{\link{uWMW}} for more details.)}
#'    \item{\code{housekeeping}:}{object of class \code{"character"}, containing either NULL or the names of the housekeeping features used in the HME version of \code{\link{uWMW}}.}
#'    \item{\code{names}:}{object of class \code{"character"}, containing the names of the features that were used in the test.}
#'    \item{\code{logOR}:}{object of class \code{"numeric"}, containing the estimated log odds ratios from the uWMW test.}
#'    \item{\code{se}:}{object of class \code{"numeric"}, containing the standard errors on the estimated log odds ratios.}
#'    \item{\code{OR}:}{object of class \code{"numeric"}, containing the odds ratios estimated by the uWMW test. This slot is accessed using the function \code{oddsRatio()}}
#'    \item{\code{z.value}:}{object of class \code{"numeric"}, containing the Z values related to the odds ratios estimated by the uWMW test. These z-values relate to the chance that a specific feature is up- or downregulated, and are used as the basis for determining the p values.}
#'    \item{\code{p.value}:}{object of class \code{"numeric"}, containing the p values related to the odds ratios estimated by the uWMW test. These p-values relate to the chance that a specific feature is up- or downregulated.}
#'    \item{\code{coef}:}{object of class \code{"numeric"}, containing the estimated coefficient of the PIM model that's used in the uWMW test.}
#'    \item{\code{vcov}:}{matrix of class \code{"numeric"}, containing the variance-covariance matrix related to the estimated coefficients.}  
#'    \item{\code{id}:}{vector of class \code{"numeric"}, containing the sorting order of the features. This slot is set using the function \code{sort}}  
#'    \item{\code{orderedBy}:}{character value, indicating whether the object contains an order and if so, based on which slot. Possible values are "none", "p", "z", "or", "se" or "name". Defaults to "none".}
#'    \item{\code{groupinfo}:}{character vector of length 2, indicating the groups. This slot is mainly used to show how the probabilistic indices are calculated.}  
#' }
#' @note For this class, \code{\link{show}} and \code{\link{length}} methods are defined. \code{\link{length}} will give you the number of features.
#' 
#' @seealso \code{\link{uwmw_Accessors}}
#'  
#' @name uwmwRes-class
#' @rdname uwmwRes-class
#' @aliases uwmwRes 
#' @exportClass uwmwRes
#' @author Joris Meys

setClass("uwmwRes",
         representation=list(type         = 'character',
                             housekeeping = 'character',
                             names        = 'character',
                             logOR        = 'numeric',
                             se           = 'numeric',
                             OR           = 'numeric',
                             z.value      = 'numeric',
                             p.value      = 'numeric',
                             coef         = 'numeric',
                             vcov         = 'matrix',
                             id           = 'numeric',
                             orderedBy      = 'character',
                             groupinfo    = 'character'
                          ),
         prototype=list(type         = character(0),
                        housekeeping = character(0),
                        names        = character(0),
                        logOR        = numeric(0),
                        se           = numeric(0),
                        OR           = numeric(0),
                        z.value      = numeric(0),
                        p.value      = numeric(0),
                        coef         = numeric(0),
                        vcov         = matrix(numeric(0),ncol=0,nrow=0),
                        id           = numeric(0),
                        orderedBy    = "none",
                        groupinfo    = character(0)
                        ),
         validity=function(object){
           
           type <- object@type
           housekeeping <- object@housekeeping
           
           if(!type %in% c("H","O")) return("type should be either H or O")
           
           # Check the lengths
           ns <- slotNames(object)
           lengths <- sapply(ns[c(3:9,11)],function(i)length(slot(object,i)))
           dims <- dim(object@vcov)

           if(type=='H'){
             # You have one coef more than features in the case of HME.
             lengths["coef"] <- lengths["coef"] - 1
             dims <- dims - 1
             if(length(housekeeping)==0)
                return("Housekeeping features are not determined")
           } else if(type=='O'){
             if(length(housekeeping)!=0)
               return("Type O does not allow housekeeping features.")
           }
           
           if(length(object@groupinfo) != 2)
             return("uwmwRes must have 2 groups")
           
           if(length(unique(c(lengths,dims)))==1) TRUE else
                 "The dimensions of the slots are incompatible" 
         }
)

# Constructor method

uwmwRes <- function(type,housekeeping,names,logOR,se,OR,
                    z.value,p.value,coef,vcov,
                    id=seq_len(length(names)),
                    orderedBy=c("none","or","p","se","name","z"),
                    groupinfo){
  orderedBy <- match.arg(orderedBy)
  new("uwmwRes",
      type=type,
      housekeeping=housekeeping,
      names=names,
      logOR=logOR,
      se=se,
      OR=OR,
      z.value=z.value,
      p.value=p.value,
      coef=coef,
      vcov=vcov,
      id=id,
      orderedBy=orderedBy,
      groupinfo=groupinfo)
}

#' Extract logor, or, odds and percentages from a uwmwRes object
#'
#' With this function you can extract the modelled (log) odds ratio, odds or
#' percentages that represent the chance on differential expression as
#' estimated by the uWMW function. It also allows to extract either the
#' standard error of or the confidence interval around the estimates.
#' See Details for more explanation.
#'
#' The function can only calculate standard errors for the log OR and
#' the log odds. In all other cases, \code{se.fit} is ignored. The function
#' takes into account a possible ordering in the object
#' (see also \code{\link[unifiedWMWqPCR:sort_uwmwRes]{sort}}). So take into account that you
#' get the estimates in the specified order. In case you want this different,
#' either use the function \code{\link{unorder}} on the object first,
#' or check if any of the \code{\link{uwmw_Accessors}} can help you out.
#'
#' The argument \code{se.fit} is mainly to be used to save calculation time.
#' Normally there's no need to set it to \code{FALSE}.
#'
#' @param x an object of the clas uwmwRes
#' @param esttype a character string indicating the measure you want to extract.
#' It can take the values \code{logor} for the log odds ratio, \code{or} for
#' the odds ratios, \code{logodds} for the log odds, \code{odds} for the odds
#' or \code{p} for the percentages.
#' @param se.fit logical value indicating whether the standard errors of the
#' logor or the log odds should be returned as well. Ignored when type has a
#' value different from \code{logor} or \code{logodds}.
#' Note that you can also use the accessor \code{\link{se}} to
#' get only the standard errors.
#' @param ci numerical value indicating the confidence interval
#' (0.95 is 95\% confidence interval). If set to TRUE, the 95% confidence
#' interval is returned. If set to NULL, no confidence interval is returned.
#' @param drop a logical value. If set to \code{TRUE} and neither \code{se} nor
#' \code{ci} is calculated, the function returns a vector instead of
#' an uwmwEstimate object.
#'
#' @return In general, a \code{\link{uwmwEstimate}} object with the
#' requested estimate. See \code{\link{uwmwEstimate}} for details.
#' In case \code{drop=TRUE} and neither the standard error nor
#' the confidence interval is calculated, a numeric named vector.
#'
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' getEstimate(NBtest,'logodds')
#' getEstimate(NBtest,'odds',ci=0.9)
#'
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @name getEstimate
#' @rdname getEstimate-methods
#' @aliases getEstimate,uwmwRes-method
setMethod("getEstimate",signature(x="uwmwRes"),
  function(x,esttype=c("logor","or","logodds","odds","p"),se.fit=(esttype %in% c("logor","logodds")),ci=TRUE,drop=TRUE){


    esttype <- match.arg(esttype)
    if(isTRUE(ci)) ci <- 0.95
    if(identical(FALSE,ci)) ci <- NULL

    xlogor <- logor(x,ordered=FALSE)
    xse    <- se(x,ordered=FALSE)
    nx     <- length(x)
    names.x <- names(x)
    xvcov <- vcov(x)

    est <- if(esttype=='logor')
              xlogor
           else if(esttype=='or')
              exp(xlogor)
           else if(esttype=='logodds')
              xlogor + coef(x)[1]
           else if(esttype=='odds')
              exp(xlogor + coef(x)[1])
            else
              1/(1 + exp(-xlogor - coef(x)[1]))


    se <- if(se.fit & esttype=="logor")
            xse
          else if(se.fit & esttype=="logodds"){

            covar <- if(type(x)=="O")
              c(xvcov[1,-1], -sum(xvcov[1,-1]))
            else
              xvcov[1,-1]

            sqrt(xse^2 + xvcov[1,1] + 2* covar)
          }
          else rep(NA,nx)

# Calculate the CI. mp is also used further on (for reference values)
    mp <- qnorm(ci+(1-ci)/2)

    if(!is.null(ci)){
      ul.logor <- (xlogor + mp * xse)
      ll.logor <- (xlogor - mp * xse)

      ul <- if(esttype=='logor')
        ul.logor
      else if(esttype=='or')
        exp(ul.logor)
      else if(esttype=='odds')
        exp(ul.logor + coef(x)[1])
      else if(esttype=="logodds")
        ul.logor + coef(x)[1]
      else if(esttype=="p")
        1/(1 + exp(-ul.logor - coef(x)[1]))
      else NA

      ll <- if(esttype=='logor')
        ll.logor
      else if(esttype=='or')
        exp(ll.logor)
      else if(esttype=='odds')
        exp(ll.logor + coef(x)[1])
      else if(esttype=="logodds")
        ll.logor + coef(x)[1]
      else if(esttype=="p")
        1/(1 + exp(-ll.logor - coef(x)[1]))
      else NA
    } else {
      ul <- ll <- as.numeric(rep(NA,nx))
    }

# Calculate the reference value for log odds and odds.
    if(!esttype %in% c("logor","or")){

      ref.logodds <- coef(x)[1]
      ref.se.logodds <- sqrt(xvcov[1,1])


      ref.ci.ub.logodds <- ref.logodds + mp*ref.se.logodds
      ref.ci.lb.logodds <- ref.logodds - mp*ref.se.logodds

      if(esttype=="odds"){
        ref <- exp(ref.logodds)
        ref.se <- NA
        ref.ci.lb <- exp(ref.ci.lb.logodds)
        ref.ci.ub <- exp(ref.ci.ub.logodds)
      } else if (esttype=="p"){
        ref <- plogis(ref.logodds)
        ref.se <- NA
        ref.ci.lb <- plogis(ref.ci.lb.logodds)
        ref.ci.ub <- plogis(ref.ci.ub.logodds)
      } else if (esttype=="logodds"){
        ref <- ref.logodds
        ref.se <- ref.se.logodds
        ref.ci.lb <- ref.ci.lb.logodds
        ref.ci.ub <- ref.ci.ub.logodds
      }
    } else {
      ref <- ref.se <- ref.ci.lb <- ref.ci.ub <- NA
    }

    id <- getOrder(x)

    if(!se.fit & is.null(ci) & drop){
      out <- est[id]
      names(out) <- names.x
      out
    } else {
    uwmwEstimate(
      esttype=esttype,
      names=names.x,
      est = est[id],
      se = se[id],
      ll = ll[id],
      ul = ul[id],
      refest = ref,
      refse = ref.se,
      reful = ref.ci.ub,
      refll = ref.ci.lb,
      type = type(x),
      confint = ci,
      housekeeping = housekeeping(x),
      groupinfo = groupinfo(x)
      )
    }

  })

# Internal Function to prepare a data frame as a matrix
prep.df <- function(x,feat.names,subjects,value){

  su <- unique(x[,subjects])
  fu <- unique(x[,feat.names])
  
  ns <- length(su)
  nf <- length(fu)
  if(nrow(x) != ns*nf)
    stop("Incomplete data currently not supported.")
  
  id <- order(x[,subjects],x[,feat.names])
  
  dmat <- matrix(x[id,value],ncol=ns,nrow=nf)
  rownames(dmat) <- sort(fu)
  colnames(dmat) <- sort(su)
  dmat
}

# Calculate the uWMW test with housekeeping genes
# 
# This is an internal function, not to be called by the user.
# input is the same as in the function \code{\link{.uWMW}}.

uWMW.H <- function(data, groups, housekeeping.names)
{
  d.m <- data
  g1 <- groups == unique(groups)[1]
  g2 <- !g1
  names.hkp <- housekeeping.names
  
  # For each feature estimate the PI and obtain sample sizes
  f.info <- t(apply(d.m, 1, wmw.f, g1, g2))
  # To avoid unstable computations, replace estimated PI of 0 by 0.01 and those of 1 by 0.99
  f.info[,1] <- ifelse(f.info[,1] > 0.999, 0.999, f.info[,1])
  f.info[,1] <- ifelse(f.info[,1] < 0.001, 0.001, f.info[,1])
  
  # In the case of multiple housekeeping features, the PI's should be averaged out. 
  boolean.hkp <- rownames(f.info) %in% names.hkp
  PI.hkp.vec <- matrix(f.info[boolean.hkp,], ncol = ncol(f.info))
  PI.hkp <- sum(PI.hkp.vec[,1]*PI.hkp.vec[,2]*PI.hkp.vec[,3])/sum(PI.hkp.vec[,2]*PI.hkp.vec[,3]) 
  
  fv <- f.info[,1]
  fv[boolean.hkp] <- PI.hkp
  
  # Convert the PI's to odds
  # for the housekeeping PI
  odds.hkp <- PI.hkp/(1 - PI.hkp)
  # for the non-housekeeping features
  f.info.nohkp <- f.info[!(rownames(f.info) %in% names.hkp),1]
  odds.f.vec <- f.info.nohkp/(1-f.info.nohkp)
  
  beta.est <- c(intercept = log(odds.hkp), log(odds.f.vec) - log(odds.hkp))
  
  # Calculate sandwich estimator in an effecient manner
  
  Outer <- outer.h.f(beta.length = length(beta.est), 
                       weights = fv*(1-fv)*f.info[,2]*f.info[,3],
                       boolean.hkp = boolean.hkp)
  
  
  Middle1 <- outer.h.f(beta.length = length(beta.est), 
                         weights = apply(d.m,1, sandwich1.f, g1, g2) - 
                           fv^2*f.info[,2]*f.info[,3]^2,
                         boolean.hkp = boolean.hkp)
  
  
  
  Middle2 <- outer.h.f(beta.length = length(beta.est), 
                         weights = apply(d.m,1, sandwich2.f, g1, g2) -
                           fv^2*f.info[,2]^2*f.info[,3],
                         boolean.hkp = boolean.hkp)
  Middle3 <- outer.h.f(beta.length = length(beta.est), 
                         weights = f.info[,2]*f.info[,3]*(fv - fv^2) - 
                           apply(d.m,1, sandwich3.f, g1, g2)/4,
                         boolean.hkp = boolean.hkp)
  Middle <- Middle1 + Middle2 - Middle3
  
  invOuter <- solve(Outer)
  
  cov.beta <- invOuter %*% Middle %*% invOuter
  return(list(logOR = beta.est[-1], SE = sqrt(diag(cov.beta))[-1], 
              coef = beta.est, vcov = cov.beta))
}

#' Extract info from uwmwRes and uwmwEstimate objects
#'
#' This help file describes different ways to access the slots and values contained in \code{\link{uwmwRes}} objects resulting from calls to \code{\link{uWMW}}, and in \code{\link{uwmwEstimate}} objects resulting from calls to \code{\link{getEstimate}}.
#'
#' @param x a uwmwRes object or a uwmwEstimate object.
#' @param ordered logical value. If set to \code{FALSE}, the extracted values are given in the original order, also after a uwmwRes object has been ordered using \code{\link{sort}}. Defaults to \code{TRUE}
#' @param na.rm for compatibility with the base function \code{\link{is.unsorted}}. Ignored for uwmwRes objects.
#' @param strictly for compatibility with the base function \code{\link{is.unsorted}}. Ignored for uwmwRes objects.
#'
#' @seealso \code{\link{uwmw_Extract}} for matrix like extraction of data.
#' @examples
#' data(NBmat)
#' NBtest <- uWMW(NBmat,NBgroups)
#' coef(NBtest)[1:10]
#' type(NBtest)
#'
#' # With a sorted object
#' NBsort <- sort(NBtest, which="p")
#' is.unsorted(NBtest)
#' is.unsorted(NBsort)
#' orderedBy(NBsort)
#'
#' # On an Estimate object
#' NBlogodds <- getEstimate(NBsort,"logodds")
#' se(NBlogodds)
#' # and so on...

#' @aliases type coef vcov ref logor esttype getOrder housekeeping orderedBy pval se zval oddsRatio groupinfo type,uwmwRes-method
#' @docType methods
#' @include uwmwRes_Class.R uwmwEstimate_Class.R allGenerics.R S3Generics.R
#' @importFrom stats coef vcov

#' @return \code{type(x)} returns the type of uWMW carried out (i.e. O or H for using overall respectively housekeeping expression as a reference.)
#' @rdname uwmw_Accessors
#' @name uwmw_Accessors
#' @aliases type
setMethod("type",signature(x="uwmwRes"),
          function(x) x@type)

#' @rdname uwmw_Accessors
#' @aliases type,uwmwEstimate-method
setMethod("type",signature(x="uwmwEstimate"),
          function(x) x@type)

# housekeeping accessor
#' @return \code{housekeeping(x)} returns the content of the housekeeping slot from the object. Or, in case of overall normalization, it returns NULL.
#' @rdname uwmw_Accessors
#' @aliases housekeeping,uwmwRes-method
setMethod("housekeeping",signature(x="uwmwRes"),
          function(x) x@housekeeping)
#' @rdname uwmw_Accessors
#' @aliases housekeeping,uwmwEstimate-method
setMethod("housekeeping",signature(x="uwmwEstimate"),
          function(x) x@housekeeping)

# names accessor
#' @export
#' @return \code{names(x)} returns the names of the genes in the object, and in the order defined in the object.
#' @rdname uwmw_Accessors
#' @aliases names,uwmwRes-method
setMethod("names",signature(x="uwmwRes"),
          function(x){
            if(!is.unsorted(x))
              x@names[x@id]
            else
              x@names
          } )
#' @rdname uwmw_Accessors
#' @aliases names,uwmwEstimate-method
setMethod("names",signature(x="uwmwEstimate"),
          function(x){
              x@names
          } )



# logor accessor
#' @return \code{logor(x)} returns a numeric vector with the log OR values.
#' @rdname uwmw_Accessors
setMethod("logor",signature(x="uwmwRes"),
          function(x,ordered=TRUE){
            if(ordered)
              x@logOR[x@id]
            else
              x@logOR
          } )

# se accessor
#' @return \code{se(x)} returns a numeric vector with the standard errors on the logor.

#' @rdname uwmw_Accessors
setMethod("se",signature(x="uwmwRes"),
          function(x,ordered=TRUE){
            if(ordered)
              x@se[x@id]
            else
              x@se
          } )

#' @rdname uwmw_Accessors
setMethod("se",signature(x="uwmwEstimate"),
          function(x){
              x@se
          } )

# OR accessor
#' @return \code{oddsRatio(x)} returns a numeric vector with the odds ratios.
#' @rdname uwmw_Accessors
#' @aliases oddsRatio,uwmwRes-method
setMethod("oddsRatio",signature(x="uwmwRes"),
          function(x,ordered=TRUE){
            if(ordered)
              x@OR[x@id]
            else
              x@se
          } )

# z.value accessor
#' @return \code{zval(x)} returns a numerical vector with the Z values contained in the object.
#' @rdname uwmw_Accessors
#' @aliases zval,uwmwRes-method
setMethod("zval",signature(x="uwmwRes"),
          function(x, ordered=TRUE){
            if(ordered)
              x@z.value[x@id]
            else
              x@z.value
          } )

# p.value accessor
#' @return \code{pval(x)} returns a numerical vector containing the p values in the object.
#' @rdname uwmw_Accessors
#' @aliases pval,uwmwRes-method
setMethod("pval",signature(x="uwmwRes"),
          function(x,ordered=TRUE){
            if(ordered)
              x@p.value[x@id]
            else
              x@p.value
          } )

# coef method\
#' @param object see \code{x}
#' @rdname uwmw_Accessors
#' @aliases coef,uwmwRes-method
#' @export
setMethod("coef",signature(object="uwmwRes"),
          function(object) {
            object@coef
          }
          )

# vcov method
#' @rdname uwmw_Accessors
#' @aliases vcov,uwmwRes-method
#' @export
setMethod("vcov",signature(object="uwmwRes"),
          function(object){
            object@vcov
          }
          )

# ref method
#' @rdname uwmw_Accessors
#' @aliases ref,uwmwEstimate-method
setMethod('ref',signature(x="uwmwEstimate"),
          function(x){
            c(refest=x@refest,
              se = x@refse,
              ll = x@refll,
              ul = x@reful)
          })
# esttype method
#' @export
#' @rdname uwmw_Accessors
#' @aliases esttype,uwmwEstimate-method
setMethod('esttype',signature(x='uwmwEstimate'),
          function(x){
            x@esttype
          })

# method getOrder
#' @rdname uwmw_Accessors
#' @aliases getOrder,uwmwRes-method
setMethod("getOrder",signature(x='uwmwRes'),
          function(x){
            x@id
          })

# method is.unsorted
#' @export
#' @rdname uwmw_Accessors
#' @aliases is.unsorted,uwmwRes-method
setGeneric("is.unsorted")
setMethod("is.unsorted",
          signature="uwmwRes",
          function(x,na.rm=FALSE,strictly=FALSE){
            if(na.rm || strictly){
              warning("The arguments na.rm and strictly are ignored when checking an uwmwRes object.")
            }
            orderedBy(x) == "none"
          })

# method orderedBy
#' @return \code{orderedBy(x)} returns the slot by which the object is ordered (i.e. the value of the slot orderedBy)
#' @rdname uwmw_Accessors
#' @aliases orderedBy,uwmwRes-method
setMethod("orderedBy",
          signature="uwmwRes",
          function(x) x@orderedBy
          )

#' @rdname uwmw_Accessors
#' @aliases orderedBy,uwmwEstimate-method
setMethod("orderedBy",
          signature="uwmwEstimate",
          function(x) x@orderedBy
)

# method orderedBy
#' @return \code{groupinfo(x)} returns the groupinfo slot, i.e. a character vector of length 2 that indicates in which order the groups are compared by uWMW.
#' @rdname uwmw_Accessors
#' @aliases groupinfo,uwmwRes-method
setMethod("groupinfo",
          signature="uwmwRes",
          function(x) x@groupinfo
)

#' @rdname uwmw_Accessors
#' @aliases groupinfo,uwmwEstimate-method
setMethod("groupinfo",
          signature="uwmwEstimate",
          function(x) x@groupinfo
)


# length method
#' @rdname uwmw_Accessors
#' @aliases length,uwmwEstimate-method
setMethod('length','uwmwEstimate',
          function(x){
            length(names(x))
          })

# length method
#' @rdname uwmw_Accessors
#' @aliases length,uwmwRes-method
setMethod('length','uwmwRes',
          function(x){
            length(names(x))
          })

#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @importFrom BiocGenerics sort
#' @importFrom stats na.omit qnorm plogis pnorm
#'
#' @export
setGeneric("forestplot",function(x,...) standardGeneric("forestplot"))

#' @export
setGeneric("volcanoplot",function(fit,...) standardGeneric("volcanoplot"))

#' @export
setGeneric("getEstimate",function(x,...) standardGeneric("getEstimate"))

#' @export
#' @rdname sort_uwmwRes
setGeneric("unorder", function(x,...) standardGeneric("unorder"))

#' @export
setGeneric("uWMW",function(x,...) standardGeneric("uWMW"))

#' @export
#' @rdname uwmw_Accessors
setGeneric("type",function(x) standardGeneric("type"))

#' @export
setGeneric('ref',function(x,...) standardGeneric('ref'))

#' @export
setGeneric("logor",function(x,...) standardGeneric("logor"))

#' @export
setGeneric('esttype',function(x,...) standardGeneric('esttype'))

#' @export
setGeneric("housekeeping",function(x) standardGeneric("housekeeping"))

#' @export
setGeneric("se",function(x,...) standardGeneric("se"))

#' @export
setGeneric("pval",function(x,...) standardGeneric("pval"))

#' @export
setGeneric("zval",function(x,...) standardGeneric("zval"))

#' @export
setGeneric("getOrder",function(x,...) standardGeneric("getOrder"))

#' @export
setGeneric("orderedBy",function(x,...)standardGeneric("orderedBy"))

#' @export
setGeneric("oddsRatio",function(x,...) standardGeneric("oddsRatio"))

#' @export
setGeneric("groupinfo",function(x,...) standardGeneric("groupinfo"))

#' @export
setGeneric("plot")
#' @export
setGeneric("coef")
#' @export
setGeneric("vcov")
#' @export
setGeneric("as.matrix")

# Estimation function based on wilcox.test
# 
# This function is internal and not to be called by the user.

#schattersfunctie op basis van wilcox
wmw.f <- function(x, g1, g2) 
{
  # deals with missing values as well (see wilcox.test.default)
  x <- x[is.finite(x)]
  
  #Calculation of the W statistics (with g2 as group 1 !!!)
  x1 <- x[g2]
  x2 <- x[g1]
  r <- rank(c(x1,x2))
  n1 <- as.double(length(x1))
  n2 <- as.double(length(x2))
  W <- sum(r[seq_along(x1)]) - n1 *(n1+1) / 2
  
  PI.est <- W/(n1*n2)
  return(c(PI.est, n1 = n1, n2 = n2))
}

# TODO : indication of significance

#' Making a forest plot of the results of uWMW
#'
#' This function creates a forest plot indicating the (log) odds ratios, the (log) odds or the probabilities for the results of the unified Wilcoxon-Mann-Whitney test.
#'
#' The function has methods for uwmwRes and uwmwEstimate objects. When called for an uwmwRes object, the requested estimate is first calculated using \code{\link{getEstimate}} and the result is passed on to the next method.
#'
#' Note that in either case, it is not possible to use the function on a subset of either type of object. The subsetting functions for \code{uwmwRes} and \code{uwmwEstimate} objects return matrices, and hence necessary information on the reference value is lost. To plot a subset of your data, use the \code{order} argument as shown in the examples.
#'
#' Adding a reference value to the plot only makes sense when plotting the log(odds), odds or probabilities. If log(OR) or OR are plotted, \code{addfit} is set to FALSE.
#'
#' The default settings plot a reference line at a location depending on the plotted estimate. For log(OR), the line is plotted at \code{refline = 0}. For OR, the line is plotted at \code{refline = 1}.
#'
#' @param x An object of class uwmwRes or uwmwEstimate.
#' @param ... parameters passed down to the internal functions. These can be any of the following.
#' @param estimate An optional character string defining which measure should be plotted. It can take the values \code{logor}, \code{or}, \code{logodds}, \code{odds} or \code{p} (for displaying the probability of differential expression, not the p-value!). Defaults to logor. Note that this argument is ignored when plotting an uwmwEstimate object.
#' @param annotate A logical value indicating whether the plot needs to be annotated, i.e. whether the values for the chosen measure and confidence interval should be displayed on the right of the plot. Defaults to TRUE
#' @param addfit A logical value indicating whether the reference measure should be plotted. See Details.
#' @param xlim The horizontal limits of the plot region. If unspecified, the function tries to set the horizontal plot limits to some sensible values. Should not be used by the user.
#' @param alim the actual x axis limits. If unspecified, an educated guess is taken by the function.
#' @param ylim The vertical limits of the plot. If unspecified, the function does what it thinks is best. Should not be used by the user.
#' @param at Position of the x axis tick marks and corresponding labels are placed. If unspecified, the function tries to position them at sensible values.
#' @param steps An integer indicating the number of tick marks on the X axis. Ignored when \code{at} is specified. Defaults to 5
#' @param level Numerical value between 0 and 1 to specify the width of the confidence interval. Defaults to 0.95 (95\% confidence interval).
#' @param digits integer specyfing the number of decimal places for tick mark labels and annotations. Can also be a vector of two integers. In that case, the first value specifies the number of decimal places for the annotations, the second for the x axis labels.
#' @param refline numerical value indicating where a reference line should be drawn. An NA value will prevent the line from being drawn. See Details.
#' @param xlab title for the x axis. If unspecified, the function tries to figure out the fitting title.
#' @param slab optional vector with names for the displayed genes.
#' @param mlab optional character string giving a label to the intercept estimate. If unspecified, this is created in the function if necessary.
#' @param ilab optional vector or matrix with character strings providing additional information that can be plotted next to the genes.
#' @param ilab.xpos Vector of numerical values specifying the x axis positions of the character vectors given via ilab. This has to be specified when ilab is specified.
#' @param ilab.pos integer from 1 to 4 specifying the alignment of the character vector(s) given via ilab (2 is right aligned, 4 is left aligned). Default is to center the labels.
#' @param order optional character string, character vector or numerical vector specifying how the genes should be ordered.
#' @param transf optional argument specifying the name of a function that should be used to transform the observed effect sizes, summary estimates, fitted values and confidence interval bounds (e.g., \code{transf=exp}). Defaults to \code{FALSE}, which means that no transformation is used.
#' @param atransf optional argument specifying the name of a function that should be used to transform the x-axis labels and annotations (e.g., transf=exp). Defaults to \code{FALSE}, which means that no transformation is used.
#' @param targs optional arguments needed by the function specified via transf or atransf.
#' @param rows optional vector specifying the horizontal position for the plotted results. If unspecified, the layout happens automatically. See Details and Examples for more information.
#' @param efac numerical value specifying the vertical expansion of the arrows, summary estimate symbols and Ci limits. Normally the default of 1 should work just fine.
#' @param pch plotting symbol used for the observed effect sizes. By default, it's a filled square.
#' @param psize optional vector with the point sizes for the observed effects. If set to \code{NULL}, the point sizes are drawn proportional to the value of the log of the test statistic. Defaults to 1.
#' @param cex optional numerical value for expansion of text and symbols. See also \code{\link{par}}.
#' @param cex.lab Optional numerical value for expansion of the axis title.
#' @param cex.axis Optional numerical value for expansion of the x axis labels.
#' @param col character string specifying the color used for the individual estimates.
#' @param border character string specifying the color used for the border of the individual estimates.
#' @param refcol Character string specyfying the color of the reference line. Defaults to red.
#' @param predcol character string specifying the color of the estimated reference value. Ignored if estimate is \code{logor} or \code{or}.
#'
#' @return NULL invisibly
#'
#' @author This code is adapted by Joris Meys from the function \code{forest.rma} (\code{metafor} package). The original function is written by W. Viechtbauer.
#'
#' @note Thanks to the work of W.Viechtbauer, \code{forestplot} provides many possibilities for tweaking and customizing the plots. Many of the arguments work the same as in the function \code{forest.rma} (\code{metafor} package). You can always check the help file of \code{forest.rma} for more illustrations on the different arguments.
#'
#' @note This function is currently implemented using an internal function that expects an uwmwEstimate object. In a future version, the internal function will be rewritten to be more generic. This will enable the definition of methods for other classes without need to change the internal function itself.
#'
#' @section Warning:
#'  Although the internal function is shown here (merely for illustration of the arguments and defaults), the user shouldn't be calling this one directly. The function is not exported.
#'
#' @examples
#'
#' data(NBmat)
#' NBtest <- uWMW(NBmat, groups=NBgroups)
#' sigid <- which(pval(NBtest) < 0.05)
#' forestplot(NBtest,"logodds",order=sigid)
#'
#' nameid <- c("hsa-mir-30a-3p","hsa-mir-30a-5p")
#' forestplot(NBtest,"p",order=nameid,addfit=FALSE,
#'            refline=NA,main="Comparison 30a")
#'
#' forestplot(NBtest,"p",order=nameid,addfit=FALSE,
#'            refline=0.5,main="Comparison 30a",
#'            alim=c(0,1),xlim=c(-1,2),at=c(0,0.5,1))
#'
#' @importFrom graphics par abline strheight segments polygon axis mtext points
#' @include uwmwRes_Class.R uwmwEstimate_Class.R
#' @name forestplot
#' @rdname forestplot-methods
#' @aliases forestplot,ANY-method
setMethod('forestplot',
          signature="ANY",
          function(x,...){
            stop("Forestplot currently only works on uwmwRes and uwmwEstimate objects. See ?uWMW and ?uwmwRes.")
          })

#' @rdname forestplot-methods
#' @aliases forestplot,uwmwRes-method
setMethod('forestplot',
          signature="uwmwRes",
          function(x,estimate=c("logor","logodds","or","odds","p"),
                   level=0.95,...){

            estimate <- match.arg(estimate)

            est <- getEstimate(x,estimate,ci=level)

            forestplot(est,level=level,...)
          })

#' @rdname forestplot-methods
#' @aliases forestplot,uwmwEstimate-method
setMethod('forestplot',
          signature="uwmwEstimate",
          function(x,...){
             forestplot.internal(x,...)
          })

#' @rdname forestplot-methods
forestplot.internal <- function (x,
                        annotate = TRUE,
                        addfit = TRUE,
                        xlim = NULL,      # Horizontal limit
                        alim = NULL,
                        ylim = NULL,
                        at = NULL,
                        steps = 5,
                        level = 0.95,
                        digits = 2,
                        refline = NULL,
                        xlab = NULL,
                        slab = NULL,
                        mlab = NULL,
                        ilab = NULL,
                        ilab.xpos = NULL,
                        ilab.pos = NULL,
                        order = NULL,
                        transf = FALSE,
                        atransf = FALSE,
                        targs = NULL,
                        rows = NULL,
                        efac = 1,
                        pch = 15,
                        psize = 1,
                        col = "darkgrey",
                        border = "darkgrey",
                        cex = NULL,
                        cex.lab = NULL,
                        cex.axis = NULL,
                        refcol="red",
                        predcol=refcol, ...)
{



  # Control arguments
  estimate <- esttype(x)

  if(estimate !='logor'){
    if(transf | atransf) warning("transf/atransf arguments are ignored when measure is not 'logor'.")
    transf <- atransf <- FALSE
  }

  na.act <- getOption("na.action")
  if (!is.element(na.act, c("na.omit", "na.exclude", "na.fail",
                            "na.pass")))
    stop("Unknown 'na.action' specified under options().")

  transf.char <- deparse(substitute(transf))
  atransf.char <- deparse(substitute(atransf))
  if (transf.char != "FALSE" && atransf.char != "FALSE")
    stop("Use either 'transf' or 'atransf' to specify a transformation (not both).")

  names.x <- names(x)
  # Check order and reorder observations if necessary.
  estmat <- as.matrix(x)
  if(!is.null(order)){
    if(is.character(order)) order <- match(order,names.x,0L)
    yi <- estmat[order,"est"]         # estimate
    ci.lb <- estmat[order,"ll"]       # ll ci
    ci.ub <- estmat[order,"ul"]       # ul ci
    names.x <- names.x[order]
    vi <- (se(x)^2)[order]     # variance of estimates
  } else {
    yi <- estmat[,"est"]                # estimate
    ci.lb <- estmat[,"ll"]              # ll ci
    ci.ub <- estmat[,"ul"]              # ul ci
    vi <- se(x)^2              # variance of estimates
  }

  k <- length(yi)                     # number of estimates

  vi[which(vi<=0)] <- NA   # Make sure all variances are valid

  # Reference value

  if(!estimate %in% c("logor","or") ){

    preds <- ref(x)
    b  <- preds['refest']
    b.ci.lb <- preds['ll']
    b.ci.ub <- preds['ul']

  } else {
    addfit <- FALSE
  }

  if(is.null(refline))
    refline <- switch(estimate,
                      "logor"= 0,
                      "or" = 1,
                      "logodds" =,
                      "odds" = ,
                      "p" = b)

  ## CONSTRUCTION OF THE PLOT

  # Determining the rows

  if (is.null(rows)) {
    rows <- seq_len(k)
  }
  else {
    if (length(rows) == 1L) {
      rows <- seq_len(rows)
    }
  }
  if (length(rows) != length(yi))
    stop("Number of outcomes does not correspond to the length of the rows argument.")

  # Get the labels if necessary
  if (is.null(slab)) {
    slab <- names.x

  }

  if (length(yi) != length(slab))
    stop("Number of outcomes does not correspond to the length of the slab argument.")

  if (is.vector(ilab))
    ilab <- cbind(ilab)

  # Take care of the pch
  if (length(pch) == 1L)
    pch <- rep(pch, k)

  if (length(pch) != length(yi))
    stop("Number of outcomes does not correspond to the length of the pch argument.")
  options(na.action = "na.exclude")

  # Check psize
  if (!is.null(psize)) {
    if (length(psize) == 1L)
      psize <- rep(psize, k)
    if (length(psize) != length(yi))
      stop("Number of outcomes does not correspond to the length of the psize argument.")
  }

  if (is.null(psize)) {
    if (any(is.na(vi))) {
      psize <- rep(1, k)
    }
    else {
      psize <- vi/sum(vi, na.rm = TRUE)
      psize <- (psize - min(psize, na.rm = TRUE)) /
        (max(psize,na.rm = TRUE) - min(psize, na.rm = TRUE))
      psize <- (psize * 1) + 0.5
    }
  }


  ##

  rng <- max(ci.ub, na.rm = TRUE) - min(ci.lb, na.rm = TRUE)
  if (annotate) {
    plot.multp.l <- 1.2
    plot.multp.r <- 1.2
    axis.multp.l <- 0.2
    axis.multp.r <- 0.2
  }
  else {
    plot.multp.l <- 1.2
    plot.multp.r <- 0.4
    axis.multp.l <- 0.2
    axis.multp.r <- 0.2
  }

  if (is.null(xlim)) {
    xlim <- c(min(ci.lb, na.rm = TRUE) - rng * plot.multp.l,
              max(ci.ub, na.rm = TRUE) + rng * plot.multp.r)
    xlim <- round(xlim, digits)
  }

  if (is.null(alim)) {
    if (is.null(at)) {
      alim <- c(min(ci.lb, na.rm = TRUE) - rng * axis.multp.l,
                max(ci.ub, na.rm = TRUE) + rng * axis.multp.r)
      alim <- round(alim, digits)
    }
    else {
      alim <- range(at)
    }
  }
  alim <- sort(alim)
  xlim <- sort(xlim)
  if (xlim[1] > min(yi, na.rm = TRUE)) {
    xlim[1] <- min(yi, na.rm = TRUE)
  }
  if (xlim[2] < max(yi, na.rm = TRUE)) {
    xlim[2] <- max(yi, na.rm = TRUE)
  }
  if (alim[1] > min(yi, na.rm = TRUE)) {
    alim[1] <- min(yi, na.rm = TRUE)
  }
  if (alim[2] < max(yi, na.rm = TRUE)) {
    alim[2] <- max(yi, na.rm = TRUE)
  }
  if (alim[1] < xlim[1]) {
    xlim[1] <- alim[1]
  }
  if (alim[2] > xlim[2]) {
    xlim[2] <- alim[2]
  }
  if (is.null(ylim)) {
    if (addfit) {
      ylim <- c(-1.5, k + 3)
    }
    else {
      ylim <- c(0.5, k + 3)
    }
  }
  else {
    ylim <- sort(ylim)
  }
  if (is.null(at)) {
    at <- seq(alim[1], alim[2], length = steps)
  }
  else {
    at[at < alim[1]] <- alim[1]
    at[at > alim[2]] <- alim[2]
    at <- unique(at)
  }

  at.lab <- at

  at.lab <- round(at.lab, digits)

  par.mar <- par("mar")
  par.mar.adj <- par.mar - c(0, 3, 1, 1)
  par.mar.adj[par.mar.adj < 1] <- 1
  par(mar = par.mar.adj)
  on.exit(par(mar = par.mar))
  plot(NA, NA, xlim = xlim, ylim = ylim, xlab = "", ylab = "",
       yaxt = "n", xaxt = "n", xaxs = "i", bty = "n", ...)
  abline(h = ylim[2] - 2, ...)
  par.usr <- par("usr")
  height <- par.usr[4] - par.usr[3]
  lheight <- strheight("O")
  cex.adj <- ifelse(k * lheight > height * 0.8, height/(1.25 *
                                                          k * lheight), 1)
  if (is.null(cex)) {
    cex <- par("cex") * cex.adj
  }
  else {
    if (is.null(cex.lab))
      cex.lab <- cex
    if (is.null(cex.axis))
      cex.axis <- cex
  }
  if (is.null(cex.lab))
    cex.lab <- par("cex") * cex.adj
  if (is.null(cex.axis))
    cex.axis <- par("cex") * cex.adj

  if (is.numeric(refline))
    segments(refline, ylim[1] - 5, refline, ylim[2] - 2,
             lty = "dotted", col=refcol, ...)

  if (addfit) {

    polygon(x = c(b.ci.lb, b, b.ci.ub, b), y = c(-1, -1 +
                                                   (height/100) * cex * efac, -1, -1 - (height/100) *
                                                   cex * efac), col = predcol, ...)
    if (is.null(mlab))
      mlab <- paste("Reference",estimate)
    text(xlim[1], -1, mlab, pos = 4, cex = cex, ...)
  }


  axis(side = 1, at = at, labels = at.lab, cex.axis = cex.axis,
       ...)

  if(is.null(xlab)) xlab <- paste("Observed Outcome:",estimate)

  if (!is.null(xlab))
    mtext(xlab, side = 1, at = min(at) + (max(at) - min(at))/2,
          line = 2.5, cex = cex.lab, ...)
  for (i in 1:k) {
    if (is.na(yi[i]) )
      next
    segments(max(ci.lb[i], alim[1]), rows[i], min(ci.ub[i],
                                                  alim[2]), rows[i], ...)
    if (ci.lb[i] >= alim[1]) {
      segments(ci.lb[i], rows[i] - (height/150) * cex *
                 efac, ci.lb[i], rows[i] + (height/150) * cex *
                 efac, ...)
    }
    else {
      polygon(x = c(alim[1], alim[1] + (1.4/100) * cex *
                      (xlim[2] - xlim[1]), alim[1] + (1.4/100) * cex *
                      (xlim[2] - xlim[1]), alim[1]), y = c(rows[i],
                                                           rows[i] + (height/150) * cex * efac, rows[i] -
                                                             (height/150) * cex * efac, rows[i]), col = "black",
              ...)
    }
    if (ci.ub[i] <= alim[2]) {
      segments(ci.ub[i], rows[i] - (height/150) * cex *
                 efac, ci.ub[i], rows[i] + (height/150) * cex *
                 efac, ...)
    }
    else {
      polygon(x = c(alim[2], alim[2] - (1.4/100) * cex *
                      (xlim[2] - xlim[1]), alim[2] - (1.4/100) * cex *
                      (xlim[2] - xlim[1]), alim[2]), y = c(rows[i],
                                                           rows[i] + (height/150) * cex * efac, rows[i] -
                                                             (height/150) * cex * efac, rows[i]), col = "black",
              ...)
    }
  }
  text(xlim[1], rows, slab, pos = 4, cex = cex, ...)
  if (!is.null(ilab)) {
    for (l in 1:NCOL(ilab)) {
      text(ilab.xpos[l], rows, ilab[, l], pos = ilab.pos[l],
           cex = cex, ...)
    }
  }

  if (annotate) {


      if (addfit) {
        annotext <- round(cbind(c(yi, b), c(ci.lb, b.ci.lb),
                                c(ci.ub, b.ci.ub)), digits)
      }
      else {
        annotext <- round(cbind(yi, ci.lb, ci.ub), digits)
      }



    annotext <- matrix(apply(annotext, 2, format, nsmall = digits),
                         ncol = 3)
    annotext <- cbind(annotext[, 1], " [ ", annotext[,
                                                       2], " , ", annotext[, 3], " ]")

    annotext <- apply(annotext, 1, paste, collapse = "")
    if (addfit) {
      text(x = xlim[2], c(rows, -1), labels = annotext,
           pos = 2, cex = cex, ...)
    }
    else {
      text(x = xlim[2], rows, labels = annotext, pos = 2,
           cex = cex, ...)
    }
  }
  points(yi, rows, pch = pch, cex = cex * psize, ...)
  if ( addfit)
    abline(h = 0, ...)
  invisible()


}

# Show methods

setMethod('show','uwmwRes',
          function(object){
            ng <- length(object)
            if(ng==0){
              cat("Empty uwmwRes object.")
              return(invisible(NULL))
            }
            typestring <- switch(object@type,"H"="housekeeping","O"="overall")
            cat("unified Wilcoxon-Mann-Whitney test \n")
            cat("with",typestring,"normalization\n")
            cat("number of features:",ng,"\n")
            if(type(object)=='H')
              cat("number of housekeeping features:", 
                  length(housekeeping(object)),"\n\n")
            cat(groups.message(groupinfo(object)),"\n\n")
            
            invisible(NULL)
            
          })


# For uwmwEstimate
setMethod('show','uwmwEstimate',
          function(object){
            ng <- length(object)
            if(ng==0){
              cat("Empty uwmwEstimate object.")
              return(invisible(NULL))
            }
            typestring <- switch(type(object),"H"="housekeeping","O"="overall")
            cat("unified Wilcoxon-Mann-Whitney test \n")
            cat("with",typestring," normalization\n")
            cat("number of genes:",ng,"\n")
            if(type(object)=='H')
              cat("number of housekeeping features:", length(housekeeping),"\n")
            cat("Confidence limits represent a",object@confint*100,"% confidence interval.\n")
            if(!is.na(object@refest))
              cat("Reference estimate:",
                  object@refest,"(",object@refll,"-",object@reful,")\n\n")
            
            cat(groups.message(groupinfo(object)),"\n\n")
            
            print(as.matrix(object))
            
            invisible(NULL)
            
          })

\documentclass[10pt]{article}
%\VignetteIndexEntry{Using unifiedWMWqPCR}
%\VignetteIndexEntry{unifiedWMWqPCR}
 

 \usepackage{graphicx}
  \usepackage{subfigure}
 \usepackage[english]{babel}
 \usepackage{a4wide}
  \usepackage{color}
% \usepackage[cp1252]{inputenc}
\usepackage{amssymb}
  \usepackage{subfigure}
 \usepackage{amsmath,amsthm}
  \usepackage{longtable}
 \usepackage{multirow}
 \usepackage{times}
 \usepackage[bf]{caption}
 \linespread{1.0}
 \usepackage[a4paper,plainpages=false]{hyperref} % links in pdf files
 \usepackage{color}
\usepackage{epstopdf}
 \usepackage{Sweave}
   \usepackage[utf8x]{inputenc} 
\parskip 0.4cm
\parindent 0cm


\newcommand{\mb}[1]
   {\boldsymbol{#1}}
\newcommand{\trace}[1]
   {\mbox{tr}\left[#1\right]}
\newcommand{\E}[1]
  {\mathrm{E}\left(#1\right)}
\newcommand{\Var}[1]
  {\mathrm{Var}\left(#1\right)}
\newcommand{\Cov}[1]
  {\mathrm{Cov}\left(#1\right)}
\newcommand{\Cor}[1]
  {\mathrm{Cor}\left(#1\right)}
\newcommand{\norm}[2]
  {\langle #1 , #2 \rangle}
\newcommand{\bX}{\mb{X}}
\newcommand{\bx}{\mb{x}}
\newcommand{\bZ}{\mb{Z}}
\newcommand{\bz}{\mb{z}}
\newcommand{\bY}{\mb{Y}}
\newcommand{\bU}{\mb{U}}
\newcommand{\bV}{\mb{V}}
\newcommand{\bh}{\mb{h}}
\newcommand{\bg}{\mb{g}}
\newcommand{\bS}{\mb{S}}
\newcommand{\bA}{\mb{A}}
\newcommand{\bB}{\mb{B}}
\newcommand{\bsigma}{\mb{\Sigma}}
\newcommand{\btheta}{\mb{\theta}}
\newcommand{\bEta}{\mb{\eta}}
\newcommand{\bbeta}{\mb{\beta}} 
\newcommand{\balpha}{\mb{\alpha}}
\newcommand{\bgamma}{\mb{\gamma}}
\newcommand{\bphi}{\mb{\varphi}}
\newcommand{\prob}[1]{\mathrm{P}\left( #1 \right)}
\newcommand{\quant}[1]{\mathrm{Q}_{\tau}\left( #1 \right)}
\newcommand{\I}[1]{\mathrm{I}\left( #1 \right)}
\newcommand{\leqs}{\preccurlyeq}
\newcommand{\geqs}{\succcurlyeq}
\newcommand{\expit}{\mathrm{expit}}
\newcommand{\logit}{\mathrm{logit}}
\newcommand{\cH}{\mathcal{H}}
\newcommand{\odds}[1]{\mathrm{odds}\left( #1 \right)}
%\DeclareMathOperator*{\min}{min} 





\title{unifiedWMWqPCR: analyzing RT-qPCR data in R with the unified Wilcoxon--Mann--Whitney test}
\author{Jan De Neve and Joris Meys}

\SweaveOpts{concordance=TRUE}
%\SweaveOpts{concordance=TRUE}

\begin{document}


 \maketitle
\tableofcontents

The package \emph{unifiedWMWqPCR} implements the unified Wilcoxon--Mann--Whitney (uWMW) test which is designed for assessing differential expression based on reverse transcription quantitative polymerase chain reaction (RT-qPCR) data, see \cite{DeNeve2013}. In addition to the uWMW test, the package provides graphical tools for a better understanding of the data. 


\section{Introduction}

Most conventional statistical tests for analyzing RT-qPCR data require normalization before differential expression can be assessed. This normalization can have a substantial effect on the interpretation and validity of the statistical test, but this effect is often ignored. Therefore the uWMW test, as proposed in \cite{DeNeve2013}, extends the Wilcoxon--Mann--Whitney test so that the normalization is incorporated in the testing procedure. Both the effect size and the normalization have an interpretation in terms of the probability $\prob{Y \leqs Y'} := \prob{Y < Y'} + 0.5 \prob{Y = Y'}$, where $Y$ and $Y'$ denote independent responses (here quantification cycles).

We employ the same notation as in \cite{DeNeve2013}. Let the random variable $Y_{ijk}$ denote the quantification cycle $C_q$ associated with feature $i \in \{1,\ldots,m+h\}$ (a feature can for example be a gene or a microRNA) of sample $j \in \{1,\ldots,n_k\}$ (a sample can for example be a tissue or a patient) in treatment group $k \in\{1,2\}$. The first $m$ features are of interest and, if available, the last $h$ features are housekeeping features that can be used for normalization (i.e. features that are known a priori not to be associated with the treatment). In the absence of (stable) housekeeping features set $h=0$. Let $Y_{i.k}$ denote the $C_q$-value of feature $i$ for a randomly selected sample in group $k$ and let $Y_{..k}$ denote the $C_q$-value of a randomly selected feature (different from a housekeeping feature) in a randomly selected sample of the treatment group $k$. Thus $Y_{..k}$ has a distribution function that is marginalized over all features ($i=1,\ldots,m$) and over all samples ($j=1,\ldots,n_k$).  We denote the $C_q$-value of a randomly selected housekeeping feature in a randomly selected sample of treatment group $k$ as $Y_{..k}^*$.




The uWMW test tests the null hypothesis
\begin{eqnarray}\label{Eq:H0}
H_0: \prob{Y_{i.1} \leqs Y_{i.2}} = \Delta,
\end{eqnarray}
against the two-sided alternative
\[
H_1: \prob{Y_{i.1} \leqs Y_{i.2}} \neq \Delta.
\]
Here $\Delta$ denotes the normalization constant which captures variation not caused by the treatment, but due to other reasons e.g. errors in fluorescence quantification, differences in the amount of starting material and enzymatic efficiencies, among other reasons. Note that if there is no need for normalization, under the null hypothesis of no-treatment effect, $\Delta \equiv 0.5$ (i.e. it is equally likely to have up regulation in treatment group 1 than in treatment group 2), and the uWMW test is asymptotically equivalent to the Wilcoxon--Mann--Whitney test. However, for RT-qPCR data, even in the absence of a treatment effect, $\Delta \neq 0.5$ and $\Delta$ needs to be estimated from the data; see \cite{DeNeve2013} for details.

In the presence of stable housekeeping features we choose
\begin{equation}\label{Eq:Delta1}
\Delta = \prob{Y^*_{..1} \leqs Y^*_{..2}}, 
\end{equation}
and  the absence of stable housekeeping features we choose
\begin{equation}\label{Eq:Delta2}
\Delta = \prob{Y_{..1} \leqs Y_{..2}}.
\end{equation}
%%We refer to \cite{DeNeve2013} for more details. 


Null hypothesis (\ref{Eq:H0}) can be equivalently expressed in terms of the odds
\begin{equation}\label{Eq:H0_2}
H_0: \odds{Y_{i.1} \leqs Y_{i.2}} = \Delta'
\end{equation}
where $\odds{Y_{i.1} \leqs Y_{i.2}} = \prob{Y_{i.1} \leqs Y_{i.2}}/[1 - \prob{Y_{i.1} \leqs Y_{i.2}}]$ and $\Delta' = \Delta/[1-\Delta]$ or in terms of the log odds ratio
\begin{equation}\label{Eq:H0_3}
H_0: \log \frac{\odds{Y_{i.1} \leqs Y_{i.2}}}{\Delta'} = 0. 
\end{equation}




\section{Usage}


\subsection{Overall expression normalization}\label{S_ON}

We illustrate the uWMW test on the neuroblastoma microRNA (miRNA) study of \cite{Mestdagh2009}. The data are included in the package and can be loaded as follows
<<>>=
library('unifiedWMWqPCR')
data(NBmat)
dim(NBmat)
table(NBgroups)
max(NBmat)
@ 
The \texttt{NBmat} matrix contains $C_q$ values for 323 miRNAs of 61 samples and are obtained from the data of \cite{Mestdagh2009} be excluding all miRNAs with more than 85\% of undetermined values in both groups ($22$ MYCN amplified (\texttt{MNA}) samples and $39$ MYCN single copy (\texttt{MNSC}) samples) and the limit of detection is set to $35$ (i.e. all $C_q$ values exceeding $35$ are set to $35$), similar as in \cite{DeNeve2013}. 

We first consider the uWMW test with \emph{overall normalization} (i.e. with normalization constant (\ref{Eq:Delta2})). The \texttt{uWMW} function is the main function and only requires the data matrix (where rows correspond to features and columns to samples) and a vector with the same length as the number of columns in the data matrix denoting the group of each sample. Note that \texttt{uWMW} can deal with several data formats, we refer to the help-file \texttt{?uWMW} for more information.    

% with cache = true, compile .Rnw file in R with 
% library(cacheSweave)
% Sweave("vignette_unifiedWMWqPCR.Rnw", driver = cacheSweaveDriver)


%<<cache = true>>=
<<>>=
uWMW.out <- uWMW(NBmat, groups = NBgroups)
@ 
<<>>=
uWMW.out
@

There are several ways to extract information from \texttt{uWMW.out}:
<<>>=
uWMW.out[1:3]
uWMW.out[1:3,]
names.tmp <- rownames(NBmat)[1:3]
names.tmp
uWMW.out[names.tmp] 
@

The column \texttt{logor} gives the estimate of the log odds ratio in (\ref{Eq:H0_3}) with $\Delta$ given by (\ref{Eq:Delta2}) since no housekeeping features were used for normalization. To give an interpretation to these odds ratios, we need to know the group in the left hand side of the inequality in (\ref{Eq:H0}) within the probability-operator. From \texttt{Fitted probabilities} in
<<>>=
uWMW.out
@
it follows that \texttt{MNA} corresponds to the left hand side of the inequality and \texttt{MNSC} to the right hand side, i.e. $ \prob{Y_{i.\texttt{MNA}} \leqs Y_{i.\texttt{MNSC}}}$. Hence the log odds ratios correspond to $ \log( \odds{Y_{i.\texttt{MNA}} \leqs Y_{i.\texttt{MNSC}}}/\Delta')$.  The column $\texttt{se}$ gives an estimate of the standard error of the estimated log odds ratio. The column $\texttt{or}$ corresponds to the odd ratio (thus $\exp$[\texttt{logor}]), while $\texttt{z.value}$ gives the test statistic associated with the null hypothesis (\ref{Eq:H0_3}) and \texttt{p.value} is the corresponding p-value (of the two-sided alternative).  


Similar as in \cite{DeNeve2013} we can consider the miRNAs of the \emph{miR-17-92} and the \emph{miR-181} cluster of which the miRNAs are believed to be up regulated when MYCN is amplified \cite{Mestdagh2009}. 
<<>>=
selection.miRNA <- c("hsa-mir-17-3p", "hsa-mir-17-5p", "hsa-mir-18a", 
"hsa-mir-18a#","hsa-mir-19a", "hsa-mir-19b",
"hsa-mir-20a","hsa-mir-92", "hsa-mir-181a", "hsa-mir-181b")
uWMW.out[selection.miRNA]
@
Note that the p-values are unadjusted for multiple comparisons and, for example, the \texttt{p.adjust} function of the \emph{stats} package can be used to adjust them.
<<>>=
adj.pvalues <- p.adjust(uWMW.out@p.value, method = "BH")
selection.id <- match(selection.miRNA, names(uWMW.out))
adj.pvalues[selection.id]
@

Consider the miRNA \texttt{hsa-mir-92} to illustrate the interpretation. From
<<>>=
uWMW.out["hsa-mir-92"]
adj.pvalues[match("hsa-mir-92", names(uWMW.out))]
@  
it follows that the odds for upregulation when MYCN is amplified (i.e. lower $C_q$ values in \texttt{MNA}) relative to the overall odds is estimated by \Sexpr{round(uWMW.out["hsa-mir-92"][3],1)} and this odds ratio is significantly different from one at the 5\% level of significance adjusted for multiplicity ($p=$\Sexpr{round(adj.pvalues[match("hsa-mir-92", names(uWMW.out))], 5)}). Thus, when MYCN is amplified, it is more likely that \texttt{hsa-mir-92} is upregulated.



\subsection{Housekeeping normalization}

If stable housekeeping features are available, housekeeping normalization can be considered. Since the dataset \texttt{NBdata} does not contain such features, for the sake of illustration, we (incorrectly) assume that the first two features are housekeeping features. 
<<>>=
housekeeping.miRNA <- rownames(NBmat)[1:2]
housekeeping.miRNA
@
%<<cache = true>>=
<<>>=
uWMW.out2 <- uWMW(NBmat, groups = NBgroups, 
housekeeping.names = housekeeping.miRNA)
@
<<>>=
uWMW.out2
@ 
Now $\Delta$ (\ref{Eq:Delta1}) is estimated based on the features given in \texttt{housekeeping.names}. All steps of Section \ref{S_ON} can be repeated.  




\section{Graphical tools}


In order to visualize the estimated effect sizes as well as the magnitude of the p-value, a Volcano plot can be constructed.
<<label=volcano,include=FALSE>>=
volcanoplot(uWMW.out, add.ref = c("both"), ref.x = c(-log(2),log(2)), 
ref.y = -log10(0.001))
@
The plot is shown in Figure \ref{fig:voclcano}. The x-axis gives the estimated log odds ratios and the y-axis  $-\log_{10}(p)$ with $p$ the (unadjusted) p-value. The vertical lines are set $-\log(2)$ and $\log(2)$ which corresponds to an odds ratio of respectively 0.5 and 2. For example, miRNAs with an estimated odds ratio exceeding 2\footnote{i.e. the estimated odds that the miRNA is upregulated in the \texttt{MNA} group is a least twice the overall odds (which is assumed to exhibit non-differential expression)} are on the right hand side of the right vertical line.  miRNAs above the horizontal line have an unadjusted p-value less than $0.001$. It is also possible to make the volcano plot based on adjusted p-values, we refer the help-files for more information.

\begin{figure}
\begin{center}
<<label=volcano,fig=TRUE,echo=FALSE>>=
<<volcano>>
@
\end{center}
\caption{Volcano plot of all miRNAs}
\label{fig:voclcano}
\end{figure}

Figure \ref{fig:forest} shows a forest plot for the miRNAs of the \emph{miR-17-92} and the \emph{miR-181} cluster. Instead of plotting the odds ratio's, the forest plot has the option to plot the estimated probabilities given in (\ref{Eq:H0}) with 95\% confidence intervals (unadjusted for multiplicity). The red diamond on the bottom of the plot shows the estimated $\Delta$ and corresponding confidence interval. For \texttt{hsa-mir-181b}, for example, the probability $\prob{Y_{\texttt{MNA}} \leqs Y_{\texttt{MNSC}}}$ is estimated by $0.59$ with a 95\% confidence interval of $[0.44, 0.73]$. 

This probability is not significantly different from $0.5$ at the 5\% level of significance (ignoring the multiplicity for the moment). However, in a RT-qPCR setting, the estimated probability should not be compared to $0.5$ but to $\Delta$ which is estimated by $0.37$ with a 95\% confidence interval of $[0.36 , 0.38]$. Since the estimated probability of \texttt{hsa-mir-181b} is substantially higher than $0.37$, this indicates an upregulation in the \texttt{MNA} group (recall that lower $C_q$ values are associated with higher expressions). 

Furthermore, since the limits of the confidence interval of $\Delta$ are substantially different from $0.5$, this may indicate that normalization was necessary for this dataset. 

<<label=forest,include=FALSE>>=
x.label <- expression("estimated "*P(Y[MNA] < Y[MNSC]))
forestplot(uWMW.out, estimate = "p", order = selection.id, xlab = x.label) 
@

\begin{figure}[htbp!]
\begin{center}
<<label=forest,fig=TRUE,echo=FALSE>>=
<<forest>>
@
\end{center}
\caption{Forest plot for the miRNAs of the \emph{miR-17-92} and the \emph{miR-181} cluster}
\label{fig:forest}
\end{figure}

\section{Additional information}

In \cite{DeNeve2013} it is shown how the uWMW test can be reformulated as a regression problem upon using probabilistic index models \cite{Thas2012}. More specifically, they consider the model
\begin{equation}\label{EqPIM}
\prob{Y_{i.1} \leqs Y_{i.2}} = \expit(\beta_0 + \beta_i),
\end{equation}
where $\expit(x) = \exp(x)/[1 + \exp(x)]$. The estimated coefficients of the model and the estimated variance-covariance matrix can be obtained as follows (we only show the first three elements)
<<>>=
coef(uWMW.out)[1:3]
vcov(uWMW.out)[1:3,1:3]
@
%The intercept corresponds to $\beta_0$ and the other coefficients to $\beta_i$ for the associated miRNA. The estimated $\Delta$ (\ref{Eq:Delta2}) and a corresponding 95\% confidence interval can be obtained as follows.
%<<>>=
%# estimate
%(Delta <- plogis(coef(uWMW.out)[1]))
%# lower limit
%(LL.Delta <- plogis(coef(uWMW.out)[1] - qnorm(0.975)*sqrt(vcov(uWMW.out)[1,1])))
%# upper limit
%(UL.Delta <- plogis(coef(uWMW.out)[1] + qnorm(0.975)*sqrt(vcov(uWMW.out)[1,1])))
%@


\begin{thebibliography}{9}

\bibitem{DeNeve2013}
 De Neve, J. Thas, O. Ottoy, J.P. and Clement L. (2013) An extension of the Wilcoxon--Mann--Whitney test for analyzing RT-qPCR data. \emph{Statistical Applications in Genetics and Molecular Biology}. \textbf{12}, 333-346.
 
\bibitem{Mestdagh2009} 
Mestdagh, P. Van Vlierberghe, P. De Weer, A. Muth, D. Westermann, F. Speleman, F. and Vandesompele, J. (2009) A novel and universal method for microRNA RT-qPCR data normalization. \emph{Genome Biology}. \textbf{10}, R64. 
 
\bibitem{Thas2012}
Thas, O. De Neve, J. Clement, L. and Ottoy, JP. (2012) Probabilistic index models. \emph{Journal of the Royal Statistical Society - Series B}. \textbf{74}, 623-671.
\end{thebibliography}


\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as.matrix.uwmwEstimate.R
\name{as.matrix.uwmwEstimate}
\alias{as.matrix.uwmwEstimate}
\alias{as.matrix,uwmwEstimate-method}
\title{S3 method as.matrix for uwmwEstimate objects.}
\usage{
\method{as.matrix}{uwmwEstimate}(x, ...)

\S4method{as.matrix}{uwmwEstimate}(x, ...)
}
\arguments{
\item{x}{a uwmwEstimate object}

\item{...}{currently ignored}
}
\value{
A matrix with the columns specified above.
}
\description{
For \code{\link{uwmwEstimate}} objects, an \code{as.matrix} method is defined that transforms the object to a numeric matrix with the following columns:
\describe{
  \item{\code{est}:}{ The estimates}
  \item{\code{se}:}{ The standard errors on estimates.}
  \item{\code{ll}}{lower limit of the confidence interval}
  \item{\code{ul}}{upper limit of the confidence interval}
}
The row names are the names of the tested genes/features. The matrix takes the ordering in the object into account if necessary.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)
NBest <- getEstimate(NBtest,"p")
as.matrix(NBtest)

}
\author{
Joris Meys
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uWMW_Extract.R
\name{uwmw_Extract}
\alias{uwmw_Extract}
\alias{[,uwmwRes,character-method}
\alias{[,uwmwEstimate,character-method}
\alias{[,uwmwRes,ANY-method}
\alias{[,uwmwEstimate,ANY-method}
\title{Extract data from uwmwRes and uwmwEstimate objects.}
\usage{
\S4method{[}{uwmwRes,character}(x, i, j, drop = TRUE)

\S4method{[}{uwmwEstimate,character}(x, i, j, drop = TRUE)

\S4method{[}{uwmwRes,ANY}(x, i, j, drop = TRUE)

\S4method{[}{uwmwEstimate,ANY}(x, i, j, drop = TRUE)
}
\arguments{
\item{x}{a \code{\link{uwmwRes}} object}

\item{i}{numeric or character vector}

\item{j}{optional numeric or character vector}

\item{drop}{logical value. If set to FALSE and the result of the extraction is a single row or column, dimensions are dropped. Defaults to \code{TRUE}.}
}
\value{
mostly a matrix, unless \code{drop=TRUE} and a single row or column is selected. Then a vector.
}
\description{
For both uwmwRes and uwmwEstimate objects, you can use the square bracket operators to extract information much like you would do for a matrix.
}
\details{
The features can be extracted using the row index, and the estimates as
}
\examples{
# With an uwmwRes object
data(NBmat)
NBtest <- uWMW(NBmat,NBgroups)
# These two lines are the same
NBtest["hsa-mir-1"]
NBtest["hsa-mir-1", ]
# These two not
str(NBtest["hsa-mir-1",,drop=FALSE])
str(NBtest["hsa-mir-1",])
# These two give the same data, but in a different way:
se(NBtest) # unnamed
NBtest[,"se"] #

# With an uwmwEstimate object
NBodds <- getEstimate(NBtest,"odds")
gnames <- grep("let",names(NBodds),value=TRUE)
NBodds[gnames]
NBodds[gnames,c("ll","ul")]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/unifiedWMWqPCR-package.R
\docType{package}
\name{unifiedWMWqPCR-package}
\alias{unifiedWMWqPCR-package}
\alias{unifiedWMWqPCR}
\alias{uWMWqPCR}
\title{Unified Wilcoxon-Mann Whitney Test for qPCR data.}
\description{
This package allows you to carry out the unified Wilcoxon-Mann Whitney
Test for qPCR data. If you use this package for research purposes,
please cite the following article:
}
\details{
De Neve, Jan; Meys, Joris; Ottoy, Jean-Pierre; Clement, Lieven and Thas,
Olivier. "UnifiedWMWqPCR: The unified Wilcoxon-Mann-Whitney test for
analyzing RT-qPCR data in R." Bioinformatics(2014): Vol.30, Issue 17,
pp.2494-2495.

Or see \code{citation("unifiedWMWqPCR")}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMethoduwmwRes.R
\name{plot,uwmwRes-method}
\alias{plot,uwmwRes-method}
\alias{plot,uwmwRes,ANY-method}
\title{Quick forest plot of significantly up- and downregulated features.}
\usage{
\S4method{plot}{uwmwRes}(x, y, ...)
}
\arguments{
\item{x}{an uwmwRes object.}

\item{y}{ignored for uwmwRes objects}

\item{...}{arguments passed down to \code{\link{forestplot}}}
}
\value{
NULL invisibly
}
\description{
This function plots a forest plot, normally used in meta analysis, to visualize the odds ratios (OR) and confidence intervals resulting from a call to \code{\link{uWMW}}. It is the default plot function for the \code{\link{uwmwRes}} objects. The results are ordered according to significance, and only the significant results are plotted. This function calls \code{\link{forestplot}} directly.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)
plot(NBtest)

}
\seealso{
\code{\link{forestplot}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uWMW_methods.R
\name{uWMW,matrix-method}
\alias{uWMW,matrix-method}
\alias{uWMW}
\alias{uWMW,data.frame-method}
\title{The unified Wilcoxon-Mann-Whitney test for qPCR data}
\usage{
\S4method{uWMW}{matrix}(
  x,
  groups,
  housekeeping.names = NULL,
  transpose = FALSE,
  feat.names = NULL
)

\S4method{uWMW}{data.frame}(x, groups, feat.names, subjects, value, ...)
}
\arguments{
\item{x}{An object containing the qPCR measurements. See details.}

\item{groups}{A vector indicating the groups that need comparing, or a single character telling which variable in the data frame contains the groups. Make sure this vector is as long as the number of replicates in the data set.}

\item{housekeeping.names}{an (optional) vector with the names of one or more housekeeping features. Make sure those names are spelled exactly as in the object.}

\item{transpose}{In case a matrix is used, should the matrix be transposed? A matrix needs to be transposed when the columns do not represent the replicates. The function expects the columns to be replicates and the rows to be the different features.}

\item{feat.names}{An (optional) character vector with the names of the features (typically genes or microRNAs) or a single character giving the name of the feature variable. If not specified, the feature names are derived from the row names of the matrix, or from the feature names of the qPCRset object.}

\item{subjects}{An (optional) character string indicating which variable of the data frame contains the subject id's. Ignored if x is not a data frame.}

\item{value}{An (optional) character string indicating which variable of the data frame contains the values. Ignored if x is not a data frame.}

\item{...}{For passing arguments between methods and to internal functions.}
}
\value{
An object of the class \code{\link{uwmwRes}}, containing the results of the unified Wilcoxon-Mann-Whitney test. See the help page of the class \code{\link{uwmwRes}} for more information.
}
\description{
This function carries out the unified Wilcoxon-Mann-Whitney test for qPCR data. See De Neve et al. (2013) for more details.
}
\details{
This function carries out the unified Wilcoxon-Mann-Whitney test using either Overall normalization (O) or Housekeeping normalization (H) as reference (see De Neve et al., 2013). If the argument \code{housekeeping.names} is specified, housekeeping normalization is considered. Otherwise overall normalization is considered.

The function uWMW can deal with data frames and matrices. When using a data frame, you need to specify the arguments \code{groups}, \code{feat.names}, \code{subjects} and \code{value}; each one should contain the name of the related variable in the data frame.

When using a matrix, each column is assumed to be a subject and each row a feature. The argument \code{groups} should contain as much values as there are columns in the matrix.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)

data(NBdata)
NBtest <- uWMW(x = NBdata, groups = "group", sub="subject",feat="miRNA",val="Cq")
head(NBtest)
as.matrix(NBtest)

}
\references{
De Neve, J. Thas, O. Ottoy, J.P. and Clement L. (2013) An extension of the Wilcoxon-Mann-Whitney test for analyzing RT-qPCR data. Statistical Applications in genetics and Molecular Biology. 12, 333-346
}
\seealso{
\code{\link{uwmw_Accessors}} and \code{\link{uwmw_Extract}} for accessing the results, and \code{\link{volcanoplot}} and \code{\link{forestplot}} for plotting them.
}
\author{
Wrapper methods are written by Joris Meys. Internal functions are written by Jan De Neve.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/volcano-internal.R
\name{volcanopar}
\alias{volcanopar}
\alias{volcano-par}
\alias{volcanoplot-par}
\alias{volcanoplotpar}
\title{Parameters used for the function volcanoplot}
\arguments{
\item{highlight}{an integer, indicating how many of the top features should be highlighted. Defaults to 0.}

\item{names}{an optional character vector giving the names of the genes to be highlighted. If not specified, the features are numbered from most significant to least significant. Default value is \code{NULL}.}

\item{xlab}{see \code{\link{par}}. Defaults to \code{"Fit"}}

\item{ylab}{see \code{\link{par}}. Defaults to \code{"Significance"}}

\item{pch}{see \code{\link{par}}. Defaults to 16}

\item{cex}{see \code{\link{par}}. Defaults to 0.35 as in the \code{limma} package.}

\item{transf.x}{a function used to transpose the values on the X axis. Defaults to NULL, unless otherwise specified in the specific methods.}

\item{transf.y}{a function used to transpose the values on the Y axis. Defaults to NULL, unless otherwise specified in the specific method.}

\item{add.ref}{a charater value indicating if reference lines for x, y or both axes should be drawn. It takes the values "none", "x", "y" or "both". Default value is "none". If not specified but ref.x or ref.y is, then the reference line is drawn for the X and/or the Y axis.}

\item{ref.x}{a numerical vector, indicating the value or values at which the reference line(s) should be drawn on the X axis. Defaults to \code{NULL}.}

\item{ref.y}{a numerical value, indicating the value at which the reference line should be drawn on the Y axis. Defaults to \code{NULL} unless otherwise specified in the specific methods.}

\item{col.x}{The color for the reference line on the X axis. The argument is passed to the col argument of \code{\link{lines}}, so check that help page for possible values. Defaults to \code{"darkgrey"}}

\item{col.y}{see col.x, but for the Y axis. If \code{col.x} is specified and \code{col.y} is not, then the value of \code{col.x} is used for \code{col.y}.}

\item{lwd.x}{The line width for the reference line on the X axis. The argument is passed to the lwd argument of \code{\link{lines}}, so check that help page for possible values. Defaults to 1.}

\item{lwd.y}{see \code{lwd.x}, but for the Y axis. If \code{lwd.y} is not specified and \code{lwd.x} is, that value is used for \code{lwd.y} as well.}

\item{lty.x}{The line type for the reference line on the X axis. The argument is passed to the lty argument of \code{\link{lines}}, so check that help page for possible values. Defaults to 1.}

\item{lty.y}{see \code{lty.x}, but for the Y axis. If \code{lty.y} is not specified and \code{lty.x} is, that value is used for \code{lty.y} as well.}
}
\description{
The parameters described can all be used in the different \link{volcanoplot} methods.
}
\details{
The arguments \code{highlight} and \code{names} are chosen in such a way that the function can mimick the behaviour of the \code{volcanoplot} function in the package \code{limma}.
}
\note{
These parameters belong to the internal function, eventually called by the different S4 methods. This internal function is not exported, and should not be called directly.
}
\examples{
# see the help page of volcanoplot

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uwmwRes_Class.R
\docType{class}
\name{uwmwRes-class}
\alias{uwmwRes-class}
\alias{uwmwRes}
\title{Class uwmwRes}
\description{
This class represents the results of the unified Wilcoxon-Mann-Whitney test. It contains all necessary information for the vulcano and forest plots. For this class a number of methods is foreseen, among which accessors for every slot.
}
\note{
For this class, \code{\link{show}} and \code{\link{length}} methods are defined. \code{\link{length}} will give you the number of features.
}
\section{Slots}{

\describe{
   \item{\code{type}:}{object of class \code{"character"}, containing the type of analysis (either H or O, see \code{\link{uWMW}} for more details.)}
   \item{\code{housekeeping}:}{object of class \code{"character"}, containing either NULL or the names of the housekeeping features used in the HME version of \code{\link{uWMW}}.}
   \item{\code{names}:}{object of class \code{"character"}, containing the names of the features that were used in the test.}
   \item{\code{logOR}:}{object of class \code{"numeric"}, containing the estimated log odds ratios from the uWMW test.}
   \item{\code{se}:}{object of class \code{"numeric"}, containing the standard errors on the estimated log odds ratios.}
   \item{\code{OR}:}{object of class \code{"numeric"}, containing the odds ratios estimated by the uWMW test. This slot is accessed using the function \code{oddsRatio()}}
   \item{\code{z.value}:}{object of class \code{"numeric"}, containing the Z values related to the odds ratios estimated by the uWMW test. These z-values relate to the chance that a specific feature is up- or downregulated, and are used as the basis for determining the p values.}
   \item{\code{p.value}:}{object of class \code{"numeric"}, containing the p values related to the odds ratios estimated by the uWMW test. These p-values relate to the chance that a specific feature is up- or downregulated.}
   \item{\code{coef}:}{object of class \code{"numeric"}, containing the estimated coefficient of the PIM model that's used in the uWMW test.}
   \item{\code{vcov}:}{matrix of class \code{"numeric"}, containing the variance-covariance matrix related to the estimated coefficients.}  
   \item{\code{id}:}{vector of class \code{"numeric"}, containing the sorting order of the features. This slot is set using the function \code{sort}}  
   \item{\code{orderedBy}:}{character value, indicating whether the object contains an order and if so, based on which slot. Possible values are "none", "p", "z", "or", "se" or "name". Defaults to "none".}
   \item{\code{groupinfo}:}{character vector of length 2, indicating the groups. This slot is mainly used to show how the probabilistic indices are calculated.}  
}
}

\seealso{
\code{\link{uwmw_Accessors}}
}
\author{
Joris Meys
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/uwmwEstimate_Class.R
\docType{class}
\name{uwmwEstimate-class}
\alias{uwmwEstimate-class}
\alias{uwmwEstimate}
\title{The class uwmwEstimate}
\description{
This class represents an estimate object resulting from a call to \code{\link{getEstimate}}. It contains all information about the estimate, including standard errors and confidence intervals if requested. For this class a number of methods is foreseen, including the accessors for the slots. The class is sortable and can be indexed, so you can use this for making custom forest plots using the function \code{\link{forestplot}}.
}
\details{
#' @section Slots:
\describe{
   \item{\code{esttype}:}{object of class \code{"character"}, containing the estimate type. This can be logor for log odds ratio, or for odds ratio, odds, logodds for the log odds or p for the probability.}
   \item{\code{names}:}{object of class \code{"character"}, containing the names of the genes for which the estimates are calculated.}  
   \item{\code{est}:}{object of class \code{"numeric"}, containing the estimates itself.}
   \item{\code{se}:}{object of class \code{"numeric"}, containing the estimates for the standard error, if applicable.}
   \item{\code{ll}:}{object of class \code{"numeric"}, containing the lower limit of the confidence interval.}
   \item{\code{ul}:}{object of class \code{"numeric"}, containing the upper limit of the confidence interval.}
   \item{\code{refest}:}{object of class \code{"numeric"}, containing the estimate for the reference used in the analysis. Note that this only makes sense for log odds, odds and probabilities.}
   \item{\code{refse}:}{object of class \code{"numeric"}, containing the se estimate for the reference if applicable.}
   \item{\code{refll}:}{object of class \code{"numeric"}, containing the lower limit for the reference if applicable.}
   \item{\code{reful}:}{object of class \code{"numeric"}, containing the upper limit for the reference if applicable.}
   \item{\code{type}:}{vector of class \code{"character"}, containing the type of reference used in the original analysis. This can be either "O" or "H" for Overall respectively Housekeeping Expression as reference.} 
   \item{\code{confint}:}{vector of class \code{"numeric"}}, indicating the limit used for the confidence interval. 0.95 represents the 95\% confidence interval.
   \item{\code{housekeeping}:}{object of class \code{"character"}, containing either NULL or the names of the housekeeping genes used in the H version of \code{\link{uWMW}}.}
   \item{\code{groupinfo}:}{character vector of length 2, indicating the groups. This slot is mainly used to show how the probabilistic indices are calculated.} 
}
}
\note{
For this class, \code{\link{show}} and \code{\link{length}} methods are defined. \code{\link{length}} will give you the number of features.
}
\author{
Joris Meys
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/sort.uwmwRes.R
\name{unorder}
\alias{unorder}
\alias{sort}
\alias{sort,uwmwRes-method}
\alias{unorder,ANY-method}
\alias{unorder,uwmwRes-method}
\alias{order,uwmwRes-method}
\title{Sort and order method for uWMWRes objects}
\usage{
unorder(x, ...)

\S4method{sort}{uwmwRes}(
  x,
  decreasing = FALSE,
  which = c("or", "p", "se", "name", "z"),
  na.last = TRUE,
  ...
)

\S4method{unorder}{ANY}(x, ...)

\S4method{unorder}{uwmwRes}(x, ...)

\S4method{order}{uwmwRes}(
  ...,
  na.last = TRUE,
  decreasing = FALSE,
  method = c("auto", "shell", "radix")
)
}
\arguments{
\item{x}{a uwmwRes object}

\item{...}{currently ignored}

\item{decreasing}{a logical value indicating whether values should be sorted in increasing or decreasing order.}

\item{which}{a character value indicating on which values should be used to sort on. The possible values are: "or" for sorting on the odds ratio, "p" for sorting on the p value, "se" for sorting on the standard error or "name" for sorting on the gene names.}

\item{na.last}{a logical value indicating whether NA results should be sorted at the end. See \code{\link{order}} for more information.}

\item{method}{Argument of the generic, ignored here. See also
\code{\link[BiocGenerics]{order}}}
}
\value{
\code{sort} returns a sorted uwmwRes object.
}
\description{
This functions provide sorting functionality for \code{\link{uwmwRes}} objects. It allows to sort the values in the object in order to get the genes with the highest OR, lowest p value, ... The function uses \code{\link{order}} underneath
}
\details{
The function does not change the internal order, but changes the slot \code{id} in the object. This slot is used by other functions to give the requested values
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)
NBsort <- sort(NBtest,which="name")
NBsort[1:10]

}
\seealso{
The functions \code{\link{is.unsorted}}, \code{\link{orderedBy}} and \code{\link{getOrder}} to check on the ordered state of a \code{\link{uwmwRes}} object.

\code{order} returns the order of the uwmwRes object.

\code{unorder} returns a uwmwRes object with the order removed.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Datasets.R
\docType{data}
\name{NBdata}
\alias{NBdata}
\alias{NBmat}
\alias{NBgroups}
\title{Documentation for the dataset NBdata}
\description{
The example data used in this package, are a subset of the data provided by Mestdagh et al. (2009). The subset contains quantification cycles of 323 microRNAs in 61 neuroblastoma (NB) tumor samples: 22 MYCN amplified (called MNA) and 39 MYCN single copy samples (called MNSC). The subset was selected so that all microRNAs with a least 85% undetermined values in both groups were removed, see De Neve et al. (2013) for details.
}
\details{
The data exists in different formats. \code{NBdata} gives you a data frame with following variables:
\describe{
 \item{\code{subject}:}{variable of class \code{"factor"}, indicating the subject code.}
 \item{\code{miRNA}:}{variable of class \code{"factor"}, indicating the miRNA code.}
 \item{\code{Cq}:}{variable of class \code{"numeric"}, containing the cycle information.}
 \item{\code{group}:}{variable of class \code{"factor"}, indicating the group code.}
}

The data matrix \code{NBmat} contains the same data in matrix format, where the rows are the different miRNA's and the columns the different subjects. The vector \code{NBgroups} specifies to which group every column of \code{NBmat} belongs.
}
\examples{
# Look at the data frame
data(NBdata)
str(NBdata)

# Look at the matrix and grouping vector
data(NBmat)
str(NBmat)
str(NBgroups)
 
}
\references{
Mestdagh, P., P. Van Vlierberghe, A. De Weer, D. Muth, F. Westermann, F. Speleman, and J. Vandesompele (2009) A novel and universal method for microRNA RT-qPCR data normalization. Genome Biology., 10, R64.

De Neve, J. Thas, O. Ottoy, J.P. and Clement L. (2013) An extension of the Wilcoxon-Mann-Whitney test for analyzing RT-qPCR data. Statistical Applications in Genetics and Molecular Biology. 12, 333-346.
}
\keyword{data}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/as.matrix.uwmwRes.R
\name{as.matrix.uwmwRes}
\alias{as.matrix.uwmwRes}
\alias{as.matrix,uwmwRes-method}
\title{S3 method as.matrix for uwmwRes objects.}
\usage{
\method{as.matrix}{uwmwRes}(x, ...)

\S4method{as.matrix}{uwmwRes}(x, ...)
}
\arguments{
\item{x}{a uwmwRes object}

\item{...}{currently ignored}
}
\value{
A matrix containing the columns specified above.
}
\description{
For \code{\link{uwmwRes}} objects, an \code{as.matrix} method is defined that transforms the object to a numeric matrix with the following columns:
\describe{
  \item{\code{logor}:}{ The log odds ratio values}
  \item{\code{se}:}{ The standard errors on the log OR values.}
  \item{\code{or}}{The odds ratio values}
  \item{\code{z.value}}{the z values related to the log OR values}
  \item{\code{p.value}}{The p values related to the log OR values}
}
The row names are the names of the tested genes/features. The matrix takes the ordering in the object into account if necessary.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)
as.matrix(NBtest)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/allGenerics.R, R/uwmw_Accessors.R
\docType{methods}
\name{type}
\alias{type}
\alias{uwmw_Accessors}
\alias{coef}
\alias{vcov}
\alias{ref}
\alias{logor}
\alias{esttype}
\alias{getOrder}
\alias{housekeeping}
\alias{orderedBy}
\alias{pval}
\alias{se}
\alias{zval}
\alias{oddsRatio}
\alias{groupinfo}
\alias{type,uwmwRes-method}
\alias{type,uwmwEstimate-method}
\alias{housekeeping,uwmwRes-method}
\alias{housekeeping,uwmwEstimate-method}
\alias{names,uwmwRes-method}
\alias{names,uwmwEstimate-method}
\alias{logor,uwmwRes-method}
\alias{se,uwmwRes-method}
\alias{se,uwmwEstimate-method}
\alias{oddsRatio,uwmwRes-method}
\alias{zval,uwmwRes-method}
\alias{pval,uwmwRes-method}
\alias{coef,uwmwRes-method}
\alias{vcov,uwmwRes-method}
\alias{ref,uwmwEstimate-method}
\alias{esttype,uwmwEstimate-method}
\alias{getOrder,uwmwRes-method}
\alias{is.unsorted}
\alias{is.unsorted,uwmwRes-method}
\alias{orderedBy,uwmwRes-method}
\alias{orderedBy,uwmwEstimate-method}
\alias{groupinfo,uwmwRes-method}
\alias{groupinfo,uwmwEstimate-method}
\alias{length,uwmwEstimate-method}
\alias{length,uwmwRes-method}
\title{Extract info from uwmwRes and uwmwEstimate objects}
\usage{
type(x)

\S4method{type}{uwmwRes}(x)

\S4method{type}{uwmwEstimate}(x)

\S4method{housekeeping}{uwmwRes}(x)

\S4method{housekeeping}{uwmwEstimate}(x)

\S4method{names}{uwmwRes}(x)

\S4method{names}{uwmwEstimate}(x)

\S4method{logor}{uwmwRes}(x, ordered = TRUE)

\S4method{se}{uwmwRes}(x, ordered = TRUE)

\S4method{se}{uwmwEstimate}(x)

\S4method{oddsRatio}{uwmwRes}(x, ordered = TRUE)

\S4method{zval}{uwmwRes}(x, ordered = TRUE)

\S4method{pval}{uwmwRes}(x, ordered = TRUE)

\S4method{coef}{uwmwRes}(object)

\S4method{vcov}{uwmwRes}(object)

\S4method{ref}{uwmwEstimate}(x)

\S4method{esttype}{uwmwEstimate}(x)

\S4method{getOrder}{uwmwRes}(x)

is.unsorted(x, na.rm = FALSE, strictly = FALSE)

\S4method{orderedBy}{uwmwRes}(x)

\S4method{orderedBy}{uwmwEstimate}(x)

\S4method{groupinfo}{uwmwRes}(x)

\S4method{groupinfo}{uwmwEstimate}(x)

\S4method{length}{uwmwEstimate}(x)

\S4method{length}{uwmwRes}(x)
}
\arguments{
\item{x}{a uwmwRes object or a uwmwEstimate object.}

\item{ordered}{logical value. If set to \code{FALSE}, the extracted values are given in the original order, also after a uwmwRes object has been ordered using \code{\link{sort}}. Defaults to \code{TRUE}}

\item{object}{see \code{x}}

\item{na.rm}{for compatibility with the base function \code{\link{is.unsorted}}. Ignored for uwmwRes objects.}

\item{strictly}{for compatibility with the base function \code{\link{is.unsorted}}. Ignored for uwmwRes objects.}
}
\value{
\code{type(x)} returns the type of uWMW carried out (i.e. O or H for using overall respectively housekeeping expression as a reference.)

\code{housekeeping(x)} returns the content of the housekeeping slot from the object. Or, in case of overall normalization, it returns NULL.

\code{names(x)} returns the names of the genes in the object, and in the order defined in the object.

\code{logor(x)} returns a numeric vector with the log OR values.

\code{se(x)} returns a numeric vector with the standard errors on the logor.

\code{oddsRatio(x)} returns a numeric vector with the odds ratios.

\code{zval(x)} returns a numerical vector with the Z values contained in the object.

\code{pval(x)} returns a numerical vector containing the p values in the object.

\code{orderedBy(x)} returns the slot by which the object is ordered (i.e. the value of the slot orderedBy)

\code{groupinfo(x)} returns the groupinfo slot, i.e. a character vector of length 2 that indicates in which order the groups are compared by uWMW.
}
\description{
This help file describes different ways to access the slots and values contained in \code{\link{uwmwRes}} objects resulting from calls to \code{\link{uWMW}}, and in \code{\link{uwmwEstimate}} objects resulting from calls to \code{\link{getEstimate}}.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat,NBgroups)
coef(NBtest)[1:10]
type(NBtest)

# With a sorted object
NBsort <- sort(NBtest, which="p")
is.unsorted(NBtest)
is.unsorted(NBsort)
orderedBy(NBsort)

# On an Estimate object
NBlogodds <- getEstimate(NBsort,"logodds")
se(NBlogodds)
# and so on...
}
\seealso{
\code{\link{uwmw_Extract}} for matrix like extraction of data.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/volcanoplot.R
\docType{methods}
\name{volcanoplot}
\alias{volcanoplot}
\alias{volcanoplot,uwmwRes-method}
\alias{volcanoplot,matrix-method}
\alias{volcanoplot,numeric-method}
\alias{volcanoplot,MArrayLM-method}
\title{Make a volcano plot of the outcome of a uWMW test}
\usage{
\S4method{volcanoplot}{uwmwRes}(
  fit,
  esttype = c("logor", "or", "logodds", "odds", "p"),
  transf.y = function(i) -log10(i),
  ref.y = -log10(0.05),
  ...
)

\S4method{volcanoplot}{matrix}(fit, ...)

\S4method{volcanoplot}{numeric}(fit, ...)

\S4method{volcanoplot}{MArrayLM}(fit, coef = 1, highlight = 0, ...)
}
\arguments{
\item{fit}{a uwmwRes object, a matrix with 2 columns or a numeric vector with either odds ratios or the log of odds ratios.}

\item{esttype}{The estimate that should be plotted from the uwmwRes object. See also \code{\link{getEstimate}}.}

\item{transf.y}{a function used to transpose the values on the Y axis. For uwmwRes objects, defaults to -log10(y). Passed down to internal function.}

\item{ref.y}{The location on the Y axis for the reference line.}

\item{...}{arguments passed to the internal function. See \code{\link{volcanopar}}}

\item{coef}{for compatibility with limma package, see \code{\link{volcanopar}}}

\item{highlight}{for compatibiity with limma package, see \code{\link{volcanopar}}}
}
\value{
invisible NULL
}
\description{
This function creates a volcano plot of the outcome of a uWMW test. In this plot, the p-value is plotted against the odd ratio or the log-odds ratio, depending on what interests you most. It allows to quickly see what proportion of results is significant, and what proportion of significant results has a biologically significant chance of being upregulated.
}
\details{
The methods described here all use the same internal function to create the plot
}
\examples{
data(NBmat)
housekeeping.id <- grep("let",rownames(NBmat),value=TRUE)
NB.Htest <- uWMW(NBmat,NBgroups,housekeeping.id)

volcanoplot(NB.Htest)
volcanoplot(NB.Htest,"p")

}
\author{
Joris Meys
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getEstimate_methods.R
\name{getEstimate}
\alias{getEstimate}
\alias{getEstimate,uwmwRes-method}
\title{Extract logor, or, odds and percentages from a uwmwRes object}
\usage{
\S4method{getEstimate}{uwmwRes}(
  x,
  esttype = c("logor", "or", "logodds", "odds", "p"),
  se.fit = (esttype \%in\% c("logor", "logodds")),
  ci = TRUE,
  drop = TRUE
)
}
\arguments{
\item{x}{an object of the clas uwmwRes}

\item{esttype}{a character string indicating the measure you want to extract.
It can take the values \code{logor} for the log odds ratio, \code{or} for
the odds ratios, \code{logodds} for the log odds, \code{odds} for the odds
or \code{p} for the percentages.}

\item{se.fit}{logical value indicating whether the standard errors of the
logor or the log odds should be returned as well. Ignored when type has a
value different from \code{logor} or \code{logodds}.
Note that you can also use the accessor \code{\link{se}} to
get only the standard errors.}

\item{ci}{numerical value indicating the confidence interval
(0.95 is 95\% confidence interval). If set to TRUE, the 95% confidence
interval is returned. If set to NULL, no confidence interval is returned.}

\item{drop}{a logical value. If set to \code{TRUE} and neither \code{se} nor
\code{ci} is calculated, the function returns a vector instead of
an uwmwEstimate object.}
}
\value{
In general, a \code{\link{uwmwEstimate}} object with the
requested estimate. See \code{\link{uwmwEstimate}} for details.
In case \code{drop=TRUE} and neither the standard error nor
the confidence interval is calculated, a numeric named vector.
}
\description{
With this function you can extract the modelled (log) odds ratio, odds or
percentages that represent the chance on differential expression as
estimated by the uWMW function. It also allows to extract either the
standard error of or the confidence interval around the estimates.
See Details for more explanation.
}
\details{
The function can only calculate standard errors for the log OR and
the log odds. In all other cases, \code{se.fit} is ignored. The function
takes into account a possible ordering in the object
(see also \code{\link[unifiedWMWqPCR:sort_uwmwRes]{sort}}). So take into account that you
get the estimates in the specified order. In case you want this different,
either use the function \code{\link{unorder}} on the object first,
or check if any of the \code{\link{uwmw_Accessors}} can help you out.

The argument \code{se.fit} is mainly to be used to save calculation time.
Normally there's no need to set it to \code{FALSE}.
}
\examples{
data(NBmat)
NBtest <- uWMW(NBmat, groups=NBgroups)
getEstimate(NBtest,'logodds')
getEstimate(NBtest,'odds',ci=0.9)

}
